(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@angular/common/locales/tr'), require('@ngx-translate/http-loader'), require('@ngx-translate/core'), require('@angular/common/http'), require('@angular/material/core'), require('@angular/platform-browser'), require('@angular/material/tooltip'), require('cl-angular-pager'), require('cl-angular-core'), require('cl-angular-combobox'), require('cl-angular-checkbox'), require('cl-angular-date-picker'), require('alasql'), require('xlsx'), require('@angular/material/dialog'), require('@angular/router'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('cl-angular-data-table', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@angular/common/locales/tr', '@ngx-translate/http-loader', '@ngx-translate/core', '@angular/common/http', '@angular/material/core', '@angular/platform-browser', '@angular/material/tooltip', 'cl-angular-pager', 'cl-angular-core', 'cl-angular-combobox', 'cl-angular-checkbox', 'cl-angular-date-picker', 'alasql', 'xlsx', '@angular/material/dialog', '@angular/router', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['cl-angular-data-table'] = {}, global.ng.core, global.ng.common, global.ng.forms, global.ng.common.locales.tr, global.httpLoader, global.core$1, global.ng.common.http, global.ng.material.core, global.ng.platformBrowser, global.ng.material.tooltip, global.clAngularPager, global.clAngularCore, global.clAngularCombobox, global.clAngularCheckbox, global.clAngularDatePicker, global.alasql, global.XLSX, global.ng.material.dialog, global.ng.router, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, common, forms, localeTr, httpLoader, core$1, http, core$2, platformBrowser, tooltip, clAngularPager, clAngularCore, clAngularCombobox, clAngularCheckbox, clAngularDatePicker, alasql, XLSX, dialog, router, rxjs, operators) { 'use strict';

    localeTr = localeTr && Object.prototype.hasOwnProperty.call(localeTr, 'default') ? localeTr['default'] : localeTr;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var DataTableStorageModel = /** @class */ (function () {
        function DataTableStorageModel() {
            this.isFullScreen = false;
            this.isScrollable = true;
            this.isCompressed = true;
            this.pageIndex = 0;
            this.pageCount = 50;
        }
        DataTableStorageModel.parse = function (element) {
            var item = new DataTableStorageModel();
            if (element != undefined) {
                item.filters = element[DataTableStorageModel.filtersKey];
                item.columns = element[DataTableStorageModel.columnsKey];
                item.isFullScreen = element[DataTableStorageModel.isFullScreenKey];
                item.isScrollable = element[DataTableStorageModel.isScrollableKey];
                item.isCompressed = element[DataTableStorageModel.isCompressedKey];
                item.pageIndex = element[DataTableStorageModel.pageIndexKey];
                item.pageCount = element[DataTableStorageModel.pageCountKey];
                if (item.pageCount == 0) {
                    item.pageCount = 50;
                }
            }
            return item;
        };
        DataTableStorageModel.filtersKey = "filters";
        DataTableStorageModel.columnsKey = "columns";
        DataTableStorageModel.isFullScreenKey = "isFullScreen";
        DataTableStorageModel.isScrollableKey = "isScrollable";
        DataTableStorageModel.isCompressedKey = "isCompressed";
        DataTableStorageModel.pageIndexKey = "pageIndex";
        DataTableStorageModel.pageCountKey = "pageCount";
        return DataTableStorageModel;
    }());

    var LocalStorageHandler = /** @class */ (function () {
        function LocalStorageHandler() {
        }
        LocalStorageHandler.getUserRowguid = function () {
            return LocalStorageHandler.getStringForKey(LocalStorageHandler.userRowguidKey);
        };
        LocalStorageHandler.getUserId = function () {
            var id = LocalStorageHandler.getStringForKey(LocalStorageHandler.userIdKey);
            return id ? Number(id) : 0;
        };
        LocalStorageHandler.setValueForKey = function (key, value) {
            if (value === undefined) {
                localStorage.removeItem(key);
            }
            else {
                localStorage.setItem(key, value);
            }
        };
        LocalStorageHandler.getStringForKey = function (key, defaultValue) {
            if (defaultValue === void 0) { defaultValue = null; }
            if (localStorage === undefined) {
                return defaultValue;
            }
            var value = localStorage.getItem(key);
            if (value === undefined || value === null) {
                return defaultValue;
            }
            return value;
        };
        LocalStorageHandler.setOriginalUserID = function (userID) {
            if (userID == undefined) {
                return undefined;
            }
            else {
                localStorage.setItem(LocalStorageHandler.originalUserIDKey, userID.toString());
            }
        };
        LocalStorageHandler.getOriginalUserID = function () {
            return localStorage.getItem(LocalStorageHandler.originalUserIDKey);
        };
        LocalStorageHandler.setDataTableSettings = function (dataTable) {
            if (dataTable.filters != undefined)
                dataTable.filters = dataTable.filters.filter(function (x) { return x.value != undefined; });
            localStorage.setItem(LocalStorageHandler.dataTableSettingsKey + "_" + dataTable.dataTableID, JSON.stringify(dataTable));
        };
        LocalStorageHandler.getDataTableSettings = function (dataTableID) {
            var dataTableSettings = localStorage.getItem(LocalStorageHandler.dataTableSettingsKey + "_" + dataTableID);
            dataTableSettings = JSON.parse(dataTableSettings);
            var dataTableStorageModel = DataTableStorageModel.parse(dataTableSettings);
            dataTableStorageModel.dataTableID = dataTableID;
            return dataTableStorageModel;
        };
        LocalStorageHandler.removeDataTableFilter = function (dataTableID) {
            var dtSetting = this.getDataTableSettings(dataTableID);
            dtSetting.filters = undefined;
            this.setDataTableSettings(dtSetting);
            return dtSetting;
        };
        LocalStorageHandler.userNameKey = 'userName';
        LocalStorageHandler.userEmailKey = "userEmail";
        LocalStorageHandler.tokenKey = 'token';
        LocalStorageHandler.sessionKey = 'session';
        LocalStorageHandler.userFullNameKey = 'userFullName';
        LocalStorageHandler.userIdKey = 'userId';
        LocalStorageHandler.userRowguidKey = 'userRowguid';
        LocalStorageHandler.userTypeKey = 'userType';
        LocalStorageHandler.userPhotoPathKey = 'userPhotoPath';
        LocalStorageHandler.originalUserIDKey = 'originalUserID';
        LocalStorageHandler.departments = "departments";
        LocalStorageHandler.dataTableSettingsKey = 'dataTableSettings';
        return LocalStorageHandler;
    }());

    var SelectionState;
    (function (SelectionState) {
        SelectionState[SelectionState["Selected"] = 0] = "Selected";
        SelectionState[SelectionState["PartiallySelected"] = 1] = "PartiallySelected";
        SelectionState[SelectionState["NotSelected"] = 2] = "NotSelected";
    })(SelectionState || (SelectionState = {}));
    var FilterItem = /** @class */ (function () {
        function FilterItem() {
            this.selected = false;
            this.enabled = true;
            this.activated = false;
            this.selectionState = SelectionState.NotSelected;
            this.readonly = false;
            this.observers = new Array();
            this.childSelectionText = '';
            this.maxChildDisplayLength = 3;
            this.childSelectionTexts = [];
        }
        FilterItem.prototype.toggleSelection = function () {
            if (this.children !== undefined && this.children.length === 0) {
                this.setSelected(!this.selected);
            }
        };
        FilterItem.prototype.setSelected = function (value) {
            var _this = this;
            this.selected = value;
            this.setSelectionState();
            this.observers.forEach(function (observer) { return observer.selectedChanged(_this); });
        };
        FilterItem.prototype.setSelectionState = function () {
            if (this.selected) {
                this.selectionState = SelectionState.Selected;
            }
            else {
                this.selectionState = SelectionState.NotSelected;
            }
        };
        FilterItem.prototype.getSelected = function () {
            return this.selected;
        };
        FilterItem.parseList = function (objects) {
            if (objects == undefined)
                return undefined;
            var items = new Array();
            objects.forEach(function (element) {
                items.push(FilterItem.parse(element));
            });
            return items;
        };
        FilterItem.parse = function (element) {
            if (element == undefined)
                return undefined;
            var filterItem = new FilterItem();
            filterItem.key = element['key'];
            filterItem.value = element['value'];
            return filterItem;
        };
        FilterItem.prototype.selectedChanged = function (item) {
            var _this = this;
            var selectedChildren = this.children.filter(function (child) { return child.selectionState === SelectionState.Selected; });
            if (selectedChildren.length === 0) {
                var hasPartiallySelectedChild = this.children.some(function (child) { return child.selectionState === SelectionState.PartiallySelected; });
                if (hasPartiallySelectedChild) {
                    this.selectionState = SelectionState.PartiallySelected;
                }
                else {
                    this.selectionState = SelectionState.NotSelected;
                }
            }
            else if (this.children.length === selectedChildren.length) {
                this.selectionState = SelectionState.Selected;
            }
            else {
                this.selectionState = SelectionState.PartiallySelected;
            }
            item.setParentSelectionText();
            this.observers.forEach(function (observer) { return observer.selectedChanged(_this); });
        };
        FilterItem.prototype.setParentSelectionText = function () {
            var text = this.key;
            var shouldAdd = this.selectionState === SelectionState.Selected;
            if (this.children === undefined || this.children.length > 0) {
                return;
            }
            var activeItem = this.parent;
            while (activeItem !== undefined) {
                var index = activeItem.childSelectionTexts.indexOf(text);
                if (index > -1 && !shouldAdd) {
                    activeItem.childSelectionTexts.splice(index, 1);
                }
                else if (index === -1 && shouldAdd) {
                    activeItem.childSelectionTexts.push(text);
                }
                if (activeItem.childSelectionTexts.length >= this.maxChildDisplayLength) {
                    activeItem.childSelectionText = activeItem.childSelectionTexts.length + 'adet seçili';
                }
                else {
                    activeItem.childSelectionText = activeItem.childSelectionTexts.join(', ');
                }
                activeItem = activeItem.parent;
            }
        };
        FilterItem.prototype.setAndObserveChildren = function (children) {
            this.children = new Array();
            this.addAndObserveChildren(children);
        };
        FilterItem.prototype.addAndObserveChildren = function (children) {
            var _this = this;
            children.forEach(function (child) { return _this.addAndObserveChild(child); });
        };
        FilterItem.prototype.refreshSelectionState = function () {
            var _this = this;
            if (this.children !== undefined && this.children.length > 0) {
                this.children.forEach(function (child) {
                    child.refreshSelectionState();
                    _this.selectedChanged(child);
                });
            }
        };
        FilterItem.prototype.addAndObserveChild = function (child) {
            if (this.children === undefined) {
                this.children = new Array();
            }
            this.children.push(child);
            if (child.observers.indexOf(this) === -1) {
                child.observers.push(this);
            }
        };
        FilterItem.prototype.getSelectedChildren = function () {
            var selectedItems = [];
            if (this.children !== undefined && this.children.length === 0) {
                if (this.selectionState === 0) {
                    if (selectedItems.indexOf(this) === -1) {
                        selectedItems.push(this);
                    }
                }
                return selectedItems;
            }
            else if (this.children !== undefined && this.children.length > 0) {
                this.children.forEach(function (item) {
                    selectedItems.push.apply(selectedItems, __spread(item.getSelectedChildren()));
                });
            }
            return selectedItems;
        };
        return FilterItem;
    }());
    Array.prototype.asFilter = function () {
        return this.map(function (x) { return x.asFilterItem(x); });
    };
    Array.prototype.clone = function () {
        return this.map(function (x) { return x.clone(); });
    };

    var Filter = /** @class */ (function () {
        function Filter() {
            this.loading = true;
            // 0 : text
            // 1 : numeric
            // 2 : date
            // 3 : bool
            // 4 : select
            this.type = 0;
            this.allowMultipleSelections = true;
            this.sourceTableSearchKeys = ["Name"];
            this.autoFilterRequestEnabled = true;
        }
        Filter.parseList = function (objects) {
            if (objects == undefined)
                return undefined;
            var items = new Array();
            objects.forEach(function (element) {
                items.push(Filter.parse(element));
            });
            return items;
        };
        Filter.parse = function (element) {
            if (element == undefined)
                return undefined;
            var filter = new Filter();
            filter.type = element["type"];
            filter.sourceTable = element["sourceTable"];
            if (element["sourceTableSearchKeys"] != undefined)
                filter.sourceTableSearchKeys = element["sourceTableSearchKeys"];
            filter.placeholder = element["displayText"];
            filter.filterKey = element["filterKey"];
            if (element["autoFilterRequestEnabled"] != undefined)
                filter.autoFilterRequestEnabled = element["autoFilterRequestEnabled"];
            filter.items = FilterItem.parseList(element["items"]);
            if (filter.items !== undefined && filter.items.length > 0)
                filter.loading = false;
            var valueMap = element["valueMap"];
            if (valueMap !== undefined) {
                filter.valueMap = new clAngularCore.Dictionary();
                valueMap.forEach(function (map) {
                    if (map["key"] !== undefined && map["value"] !== undefined)
                        filter.valueMap.add(map["key"], map["value"]);
                });
            }
            return filter;
        };
        return Filter;
    }());

    var Condition = /** @class */ (function () {
        function Condition() {
            this.shouldOperationFallbackToDefaultTemplate = true;
            this.direction = true;
        }
        Condition.parseList = function (objects) {
            if (objects == undefined)
                return undefined;
            var items = new Array();
            objects.forEach(function (element) {
                items.push(Condition.parse(element));
            });
            return items;
        };
        Condition.parse = function (element) {
            if (element == undefined)
                return undefined;
            var condition = new Condition();
            condition.condition = element["condition"];
            condition.operationCondition = element["operationCondition"];
            condition.field = element["field"];
            condition.template = element["template"];
            condition.operationTemplate = element["operationTemplate"];
            condition.direction = element["direction"];
            if (condition.direction == undefined)
                condition.direction = true;
            return condition;
        };
        return Condition;
    }());

    var NestedDataStrategy;
    (function (NestedDataStrategy) {
        NestedDataStrategy[NestedDataStrategy["None"] = 0] = "None";
        NestedDataStrategy[NestedDataStrategy["Concat"] = 1] = "Concat";
        NestedDataStrategy[NestedDataStrategy["Divide"] = 2] = "Divide";
    })(NestedDataStrategy || (NestedDataStrategy = {}));
    var Column = /** @class */ (function () {
        function Column() {
            this.index = 0;
            this.nestedDataStrategy = NestedDataStrategy.None;
            this.concatStrategy = ', ';
            this.displayText = "";
            this.supportsSorting = true;
            this.sortDirection = 2;
            this.filterEnabled = false;
            this.type = "data";
            this.format = "dd.MM.yyyy";
            this.isComputed = false;
            this.isActive = true;
            this.supportsGrouping = false;
            this.grouped = false;
            this.enableAddon = false;
            this.actionButtonDisplayText = "";
        }
        Column.prototype.toggleSort = function () {
            if (this.sortDirection == 2)
                this.sortDirection = -1;
            this.sortDirection += 1;
        };
        Column.prototype.getTemplate = function (item) {
            for (var index in this.conditions) {
                var condition = this.conditions[index];
                var data = this.extractValue(item, condition.field);
                if (condition.condition == data) {
                    if (condition.operationCondition == undefined) {
                        return condition.template;
                    }
                    else if (item["__operationState"] == condition.operationCondition) {
                        return condition.operationTemplate;
                    }
                    if (condition.shouldOperationFallbackToDefaultTemplate) {
                        return condition.template;
                    }
                }
            }
            return item[this.field];
        };
        Column.prototype.extractValue = function (item, field, returnLength) {
            if (returnLength === void 0) { returnLength = true; }
            try {
                if (field == undefined)
                    return "";
                if (field.indexOf('.') < 0) {
                    if (item !== undefined && item.hasOwnProperty(field)) {
                        var data = item[field];
                        if (data instanceof Array) {
                            return returnLength ? data.length : data;
                        }
                        else {
                            return data;
                        }
                    }
                    else
                        return '';
                }
                var keyPath = field.split('.');
                var currentItem = item;
                for (var index in keyPath) {
                    if (keyPath.hasOwnProperty(index)) {
                        var key = keyPath[index];
                        if (currentItem === undefined)
                            return "";
                        if (currentItem.hasOwnProperty(key)) {
                            currentItem = currentItem[key];
                        }
                        else
                            return "";
                    }
                }
                if (currentItem instanceof Date) {
                    return currentItem.toDateString();
                }
                if (currentItem instanceof Array) {
                    return returnLength ? currentItem.length : currentItem;
                }
                return currentItem;
            }
            catch (error) {
                console.log(error);
                return "";
            }
        };
        Column.parseList = function (objects) {
            if (objects == undefined)
                return undefined;
            var items = new Array();
            var index = 0;
            objects.forEach(function (element) {
                var column = Column.parse(element);
                column.index = index++;
                items.push(column);
            });
            return items;
        };
        Column.parse = function (element) {
            if (element == undefined)
                return undefined;
            var column = new Column();
            if (element["isActive"] !== undefined)
                column.isActive = element["isActive"];
            column.field = element["field"];
            column.moneyInputValueField = element["moneyInputValueField"];
            column.moneyInputCurrencyIDField = element["moneyInputCurrencyIDField"];
            column.displayText = element["displayText"];
            column.actionButtonDisplayText = element["actionButtonDisplayText"];
            column.conditions = Condition.parseList(element["conditions"]);
            if (element["supportsSorting"] !== undefined)
                column.supportsSorting = element["supportsSorting"];
            if (element["sortDirection"] !== undefined)
                column.sortDirection = element["sortDirection"];
            column.sortKey = element["sortKey"];
            if (column.sortKey === undefined || column.sortKey.length === 0)
                column.sortKey = column.filterKey;
            column.join = element["join"];
            column.concatStrategy = element["concatStrategy"];
            column.isComputed = element["isComputed"];
            column.minWidth = element["min-width"];
            column.format = element["format"];
            column.nestedDataStrategy = element["nestedDataStrategy"];
            column.divisionField = element["divisionField"];
            column.typeConditions = element["typeConditions"];
            column.enableAddon = element["enableAddon"];
            column.addonSymbol = element["addonSymbol"];
            column.dateMaxValueField = element["dateMaxValueField"];
            column.dateMinValueField = element["dateMinValueField"];
            column.filterKey = element["filterKey"];
            column.filterEnabled = element["filterEnabled"];
            column.filter = Filter.parse(element["filter"]);
            if (column.filter != undefined && column.filter.filterKey == undefined) {
                column.filter.filterKey = column.filterKey;
                if ((column.filter.sourceTable == undefined || column.filter.sourceTable.length == 0) &&
                    (column.join != undefined && column.join.length > 0)) {
                    column.filter.sourceTable = column.join;
                    var dotIndex = column.filter.sourceTable.lastIndexOf('.');
                    if (dotIndex > -1) {
                        column.filter.sourceTable = column.filter.sourceTable.substring(dotIndex + 1, column.filter.sourceTable.length);
                    }
                }
            }
            var type = element["type"];
            if (type != undefined) {
                column.type = type;
            }
            var selections = element["selections"];
            if (selections != undefined) {
                column.selections = selections;
            }
            return column;
        };
        Column.getIncludeStrings = function (columns) {
            var includeStrings = new Array();
            columns.forEach(function (column) {
                if (column.join != undefined) {
                    includeStrings.push(column.join);
                }
            });
            return includeStrings;
        };
        return Column;
    }());

    //import { BaseRepository } from 'app/repositories/base-repository';
    //import { CommentComponent } from '../../components/comment/comment.component';
    //import { DocumentListByownerComponent } from 'app/components/shared/document/document-list-byowner/document-list-byowner.component';
    var DataTableComponent = /** @class */ (function () {
        function DataTableComponent(dialog, router, route /*, private userDefinedFilterRepo: UserDefinedFilterRepository*/) {
            this.dialog = dialog;
            this.router = router;
            this.route = route;
            this.postInProgress = false;
            this.identifier = clAngularCore.UUID.UUID();
            this.commentsEnabled = false;
            this.documentsEnabled = false;
            this.uiSelectionEnabled = false;
            this.baseURL = "";
            this.emptyResultTemplateShownInPager = true;
            this.columnFilterEnabled = false;
            this.hasFilters = false;
            this.items = new Array();
            this.pageCount = 50;
            this.pageIndex = 0;
            this.itemCount = 0;
            this.configPath = "";
            this.configurationLoaded = false;
            this.onConfigurationLoaded = new core.EventEmitter();
            this.onFilterUpdated = new core.EventEmitter();
            this.onSortPreferenceChanged = new core.EventEmitter();
            this.onGroupPreferenceChanged = new core.EventEmitter();
            this.onPageChanged = new core.EventEmitter();
            this.onPageCountChanged = new core.EventEmitter();
            this.onUserDefinedFilterSelected = new core.EventEmitter();
            this.onInsertFormRequested = new core.EventEmitter();
            this.onEntitySelected = new core.EventEmitter();
            this.onRowSelected = new core.EventEmitter();
            this.onColumnSelected = new core.EventEmitter();
            this.onSelectionChanged = new core.EventEmitter();
            this.selectedAction = undefined;
            this.isFullScreen = false;
            this.isScrollable = true;
            this.isCompressed = true;
            this.containsNestedData = false;
            this.dataTableStorage = new DataTableStorageModel();
            this.userDefinedFilter = new UserDefinedFilterModel();
            this.comboboxSettings = new clAngularCombobox.ComboboxSettings();
            this.comboboxStyles = new clAngularCombobox.ComboboxStyles();
            this.filterManagementPageMode = FilterManagementPageMode.List;
            this.rowSelectionEnabled = false;
            this.itemSelectionChanged = false;
            this.allSelected = false;
            this.optionsMenuVisible = false;
            // Keyboard actions
            this.activeRow = undefined;
            this.activeColumn = undefined;
            this.columnCount = undefined;
            this.rowCount = undefined;
            this.rowToBeSelected = undefined;
            this.columnToBeSelected = undefined;
            this.tableSettingMode = TableSettingMode.Default;
            //super();
            //this.baseURL = new BaseRepository(undefined).apiRoot;
            //let userType = LocalStorageHandler.getUserType();
            //this.isAdmin = userType == 5;
        }
        Object.defineProperty(DataTableComponent.prototype, "dataTableID", {
            get: function () {
                return this._dataTableID;
            },
            set: function (v) {
                this.dataTableStorage.dataTableID = v;
                this._dataTableID = v;
            },
            enumerable: true,
            configurable: true
        });
        DataTableComponent.prototype.ngOnInit = function () {
            this.dataTableStorage = LocalStorageHandler.getDataTableSettings(this.dataTableID);
            this.setDataTableSettings(this.dataTableStorage, false);
            this.setComboboxSettings();
            this.loading = true;
            this.getUserDefinedFilters();
        };
        DataTableComponent.prototype.setComboboxSettings = function () {
            this.comboboxSettings.enableSearch = true;
            this.comboboxSettings.lazyLoadEnabled = true;
            this.comboboxSettings.selectionLimit = 1;
            this.comboboxSettings.closeOnSelect = true;
        };
        DataTableComponent.prototype.setDataTableSettings = function (dataTableSetting, triggerOnFilterUpdated) {
            if (triggerOnFilterUpdated === void 0) { triggerOnFilterUpdated = true; }
            this.dataTableStorage = dataTableSetting;
            if (dataTableSetting.pageCount == undefined)
                dataTableSetting.pageCount = this.pageCount;
            if (dataTableSetting.pageIndex == undefined)
                dataTableSetting.pageIndex = this.pageIndex;
            this.filters = dataTableSetting.filters;
            if (triggerOnFilterUpdated)
                this.onFilterUpdated.emit({ filter: this.filters, pageIndex: dataTableSetting.pageIndex, pageCount: dataTableSetting.pageCount });
            this.isScrollable = dataTableSetting.isScrollable;
            this.isFullScreen = dataTableSetting.isFullScreen;
            this.isCompressed = dataTableSetting.isCompressed;
            this.pageIndex = dataTableSetting.pageIndex;
            this.pageCount = dataTableSetting.pageCount;
            this.activateColumns();
            this.setActiveColumns();
        };
        DataTableComponent.prototype.clearFilters = function () {
            if (this.columns) {
                this.columns.forEach(function (column) {
                    if (column) {
                        if (column.filterEnabled && column.filter) {
                            column.filter.value = undefined;
                            if (column.filter.type == 4 && column.filter.items) {
                                column.filter.items.forEach(function (item) {
                                    item.setSelected(false);
                                });
                                column.filter.combobox.clearSelection();
                            }
                        }
                    }
                });
            }
            this.hasFilters = false;
            this.filters = undefined;
            this.onFilterUpdated.emit({ filter: undefined, pageIndex: this.dataTableStorage.pageIndex, pageCount: this.dataTableStorage.pageCount });
        };
        DataTableComponent.prototype.pageChanged = function ($event) {
            this.dataTableStorage.pageIndex = +$event ? +$event : 0;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
            if (this.onPageChanged !== undefined && this.onPageChanged.observers.length > 0) {
                this.loading = true;
                this.onPageChanged.emit($event);
            }
        };
        DataTableComponent.prototype.pageCountChanged = function ($event) {
            //this.loading = true;
            this.pageCount = +$event;
            this.dataTableStorage.pageCount = this.pageCount;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
            if (+$event == 0) {
                clAngularCore.Utils.showConfirmDialog(this.dialog, { panelClass: 'modal-dialog', data: { contentText: 'Veri sayısı çok fazla olduğundan excel halinde indirilecektir.Onaylıyor musunuz?' } }, this.confirm, this.decline, this);
                return;
            }
            this.onPageCountChanged.emit($event);
        };
        DataTableComponent.prototype.actionTriggered = function (action, item) {
            this.closeContextMenu();
            item["__operationState"] = "activating";
            action.action.call(this.context, item);
        };
        DataTableComponent.prototype.loadConfig = function (loader) {
            var _this = this;
            loader.then(function (tableConfig) {
                _this.tableConfig = tableConfig;
                _this.applyConfig(tableConfig);
            });
        };
        DataTableComponent.prototype.applyConfig = function (tableConfig) {
            this.tableConfig = tableConfig;
            if (tableConfig === undefined) {
                return;
            }
            this.enabled = tableConfig["enabled"];
            this.commentsEnabled = tableConfig["commentsEnabled"];
            this.documentsEnabled = tableConfig["documentsEnabled"];
            this.columnFilterEnabled = tableConfig["columnFilterEnabled"];
            this.columns = Column.parseList(tableConfig["columns"]);
            this.activateColumns();
            this.changeFilterState();
            this.actionColumn = Column.parse(tableConfig["actionColumn"]);
            this.configurationLoaded = true;
            this.onConfigurationLoaded.emit({ includeStrings: Column.getIncludeStrings(this.columns) });
            this.setActiveColumns();
            var division = this.getDivisionColumns();
            this.containsNestedData = division !== undefined && division.length > 0;
        };
        DataTableComponent.prototype.activateColumns = function () {
            var _this = this;
            if (this.dataTableStorage.columns != undefined && this.columns != undefined) {
                this.columns.forEach(function (column) {
                    _this.dataTableStorage.columns.forEach(function (dtColumn, i) {
                        if (column.field == dtColumn.field) {
                            column.index = i;
                            column.isActive = dtColumn.isActive;
                        }
                    });
                });
                this.columns = this.columns.sort(function (a, b) { return a.index - b.index; });
            }
            else {
                this.saveDataTableColumns();
            }
        };
        DataTableComponent.prototype.getAllItems = function () {
            return this.items;
        };
        DataTableComponent.prototype.confirm = function () {
            this.onPageCountChanged.emit(0);
        };
        DataTableComponent.prototype.decline = function () {
            return;
        };
        DataTableComponent.prototype.setItems = function (items, itemCount, pageNumber, userDefinedFilters, predefinedFilter) {
            // if (this.pageCount === 0) {
            //   Utils.showConfirmDialog(this.dialog, { panelClass: 'modal-dialog', data: { contentText: 'Veri sayısı çok fazla olduğundan excel halinde indirilecektir.Onaylıyor musunuz?' } }, this.confirm, this.decline, this);
            //   return;
            // }
            var _this = this;
            if (userDefinedFilters === void 0) { userDefinedFilters = undefined; }
            if (predefinedFilter === void 0) { predefinedFilter = undefined; }
            if (this.pageCount == 0) {
                this.exportItemsToExcel(items);
                return;
            }
            this.setPredefinedFilter(predefinedFilter);
            this.setUserDefinedFilters(userDefinedFilters);
            this.items = items;
            var division = this.getDivisionColumns();
            this.items.forEach(function (item) {
                var rowCounts = new Array();
                division.forEach(function (column) {
                    if (column.divisionField !== undefined) {
                        var value = _this.extractRawValue(item, column.divisionField, ',', false);
                        if (value instanceof Array) {
                            var length = value.length > 0 ? value.length : 1;
                            item["_" + column.divisionField + "Count"] = length;
                            rowCounts.push(length);
                        }
                    }
                });
                var lcm = _this.range_lcm(rowCounts);
                item["_rowCount"] = lcm;
                item["_rowIterator"] = Array(lcm).fill(1);
            });
            this.placeboRowHeight = 380;
            if (this.items) {
                this.placeboRowHeight = 380 - this.items.length * 50;
                this.rowCount = this.items.length;
            }
            this.itemCount = itemCount;
            this.pageIndex = pageNumber;
            this.renderItems();
            setTimeout(function () {
                if (itemCount > 0 && _this.pager !== undefined) {
                    _this.pager.flushPager(itemCount);
                }
                _this.loading = false;
            }, 10);
        };
        DataTableComponent.prototype.renderItems = function (items) {
            var _this = this;
            if (items === void 0) { items = undefined; }
            if (items == undefined)
                items = this.items;
            // console.log('Render Started: ' + new Date())
            var datePipe = new common.DatePipe('tr');
            var _loop_1 = function (index) {
                var e_1, _a;
                var item = items[index];
                item["_render"] = new Object();
                renderObject = item["_render"];
                renderObject["_deletedCondition"] = this_1.getDeletedCondition(item, index);
                renderObject["_uiSelectionEnabled"] = new Array();
                renderObject["_tdVisible"] = new Array();
                rowIteratorx = item["_rowIterator"];
                rowIteratorx.forEach(function (x, rowIndex) {
                    renderObject["_uiSelectionEnabled"].push(_this.uiSelectionEnabled && (rowIndex % item._rowCount == 0));
                    renderObject["_tdVisible"].push(rowIndex % item._rowCount == 0);
                });
                var _loop_2 = function (column) {
                    if (column.type == 'condition') {
                        renderObject["_template_" + column.index] = column.getTemplate(item);
                    }
                    else if (column.nestedDataStrategy == 2) {
                        dataList = new Array();
                        rowIterator = item["_rowIterator"];
                        rowIterator.forEach(function (x, rowIndex) {
                            var data = new Object();
                            var displayText = _this.extractDivisionValue(item, column, rowIndex);
                            if (column.type == 'date')
                                displayText = datePipe.transform(data, column.format);
                            data["displayText"] = displayText;
                            data["rowSpan"] = item._rowCount / item['_' + column.divisionField + 'Count'];
                            data["rowSpanEnabled"] = rowIndex % (item._rowCount / item['_' + column.divisionField + 'Count']) == 0;
                            renderObject[column.field] = data;
                            dataList.push(data);
                        });
                        renderObject[column.field] = dataList;
                    }
                    else {
                        data = this_1.extractValue(item, column);
                        if (column.type == 'date')
                            data = datePipe.transform(data, column.format);
                        renderObject[column.field] = data;
                    }
                };
                try {
                    for (var _b = (e_1 = void 0, __values(this_1.columns)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var column = _c.value;
                        _loop_2(column);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            };
            var this_1 = this, renderObject, rowIteratorx, dataList, rowIterator, data;
            for (var index = 0; index < items.length; index++) {
                _loop_1(index);
            }
            // console.log('Render Ended: ' + new Date())
        };
        DataTableComponent.prototype.createContextMenu = function () {
        };
        DataTableComponent.prototype.setActiveColumns = function () {
            if (this.columns == undefined || this.columns.length == 0)
                this.activeColumns = new Array();
            else
                this.activeColumns = this.columns.filter(function (row) { return row.isActive == true; });
            this.saveDataTableColumns();
            this.columnCount = this.activeColumns.length;
        };
        DataTableComponent.prototype.saveDataTableColumns = function () {
            var _this = this;
            if (this.dataTableID == undefined)
                return;
            if (this.dataTableStorage.dataTableID == undefined)
                this.dataTableStorage.dataTableID = this.dataTableID;
            if (this.columns == undefined)
                return;
            this.dataTableStorage.columns = new Array();
            this.columns.forEach(function (column, i) {
                var col = new Column();
                col.index = i;
                col.isActive = column.isActive;
                col.filterKey = column.filterKey;
                col.displayText = column.displayText;
                col.field = column.field;
                _this.dataTableStorage.columns.push(col);
            });
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
        };
        DataTableComponent.prototype.getDivisionColumns = function () {
            if (this.columns == undefined || this.columns.length == 0)
                return new Array();
            return this.columns.filter(function (row) { return row.nestedDataStrategy == NestedDataStrategy.Divide; });
        };
        DataTableComponent.prototype.setFilter = function (filter, items, operator) {
            if (operator === void 0) { operator = undefined; }
            this.columns.forEach(function (element) {
                if (element.filterEnabled == true && element.filter.type == 4) {
                    if (element.filterKey == filter) {
                        element.filter.items = items;
                        element.filter.loading = false;
                        if (operator) {
                            element.filter.operation = operator;
                        }
                    }
                }
            });
        };
        DataTableComponent.prototype.searchInputChanged = function () {
            this.onFilterChanged();
        };
        DataTableComponent.prototype.generalSearchInputChanged = function ($event) {
        };
        // this.tableStorageManager.saveFilters(this.table, this.table.name);
        DataTableComponent.prototype.onFilterChanged = function () {
            var _this = this;
            this.pageIndex = 0;
            this.dataTableStorage.pageIndex = 0;
            var filters = new Array();
            this.columns.forEach(function (element) {
                if (element.filterEnabled == true && element.filter.value != undefined) {
                    if (element.filter.type == 2 && element.filter.operation == undefined) {
                        var criteria = new clAngularCore.SearchCriteria();
                        criteria.operator = '>=';
                        criteria.key = element.filterKey;
                        criteria.value = element.filter.value;
                        filters.push(criteria);
                        criteria = new clAngularCore.SearchCriteria();
                        criteria.operator = '<';
                        criteria.key = element.filterKey;
                        var selectedDate = new Date(element.filter.value);
                        selectedDate.setDate(selectedDate.getDate() + 1);
                        criteria.value = selectedDate;
                        filters.push(criteria);
                    }
                    else {
                        var criteria = new clAngularCore.SearchCriteria();
                        criteria.operator = element.filter.operation;
                        criteria.key = element.filterKey;
                        if (element.filter.valueMap !== undefined) {
                            if (element.filter.valueMap.containsKey(element.filter.value)) {
                                criteria.value = element.filter.valueMap[element.filter.value];
                                filters.push(criteria);
                            }
                        }
                        else {
                            criteria.value = element.filter.value;
                            filters.push(criteria);
                        }
                    }
                    _this.hasFilters = true;
                }
            });
            // this.tableStorageManager.saveFilters(this.table, this.table.name);
            this.filters = filters;
            this.dataTableStorage.filters = filters;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
            this.onFilterUpdated.emit({ filter: filters, pageIndex: this.dataTableStorage.pageIndex, pageCount: this.dataTableStorage.pageCount });
        };
        DataTableComponent.prototype.changeFilterState = function () {
            var _this = this;
            if (this.dataTableStorage.filters && this.activeColumns) {
                this.dataTableStorage.filters.forEach(function (filter) {
                    _this.activeColumns.forEach(function (column) {
                        if (column.filterEnabled == true && column.filterKey == filter.key) {
                            if (column.filter.type == 4) {
                                if (column.filter.items && column.filter.items.length > 0 && filter.value && filter.value.length > 0) {
                                    filter.value.forEach(function (val) {
                                        var found = column.filter.items.find(function (item) { return item.value == val; });
                                        found.setSelected(true);
                                    });
                                }
                            }
                            else {
                                column.filter.value = filter.value;
                            }
                            _this.hasFilters = true;
                        }
                    });
                });
                this.dataTableFilters.forEach(function (x) { return x.updateFilters(); });
            }
        };
        DataTableComponent.prototype.sort = function (column) {
            if (column.supportsSorting != true)
                return;
            column.toggleSort();
            var sortPreferences = new clAngularCore.Dictionary(null);
            this.columns.forEach(function (element) {
                if (element.supportsSorting == true && !(element.sortDirection == undefined || element.sortDirection == 2)) {
                    var sortKey = element.sortKey;
                    if (sortKey == undefined || sortKey.length == 1)
                        sortKey = element.filterKey;
                    sortPreferences.add(sortKey, element.sortDirection);
                }
            });
            this.onSortPreferenceChanged.emit({ sortPreferences: sortPreferences });
        };
        DataTableComponent.prototype.group = function (column) {
            if (column.supportsGrouping != true)
                return;
            column.grouped = !column.grouped;
            var groupPreferences = new clAngularCore.Dictionary(null);
            this.columns.forEach(function (element) {
                if (element.supportsSorting == true && !(element.sortDirection == undefined || element.sortDirection == 2)) {
                    groupPreferences.add(element.sortKey, element.sortDirection);
                }
            });
            this.onGroupPreferenceChanged.emit({ groupPreferences: groupPreferences });
        };
        DataTableComponent.prototype.extractDivisionValue = function (item, column, index) {
            var value = this.extractRawValue(item, column.divisionField, ',', false);
            if (value == undefined)
                return "";
            var count = item['_' + column.divisionField + 'Count'];
            if (count == undefined)
                count = 1;
            if (item._rowCount == undefined)
                item._rowCount = 1;
            var nestedItem = value[index / (item._rowCount / (count))];
            return this.extractValue(nestedItem, column);
        };
        DataTableComponent.prototype.extractValue = function (item, column) {
            if (column.isComputed) {
                if (this.computeProperyForItem !== undefined) {
                    return this.computeProperyForItem.call(this.context, item, column.field);
                }
                else {
                    return "";
                }
            }
            var extracted = this.extractRawValue(item, column.field, column.concatStrategy);
            if (extracted !== undefined && extracted instanceof String && extracted.length > 100) {
                extracted = extracted.slice(0, 97) + "...";
            }
            return extracted;
        };
        DataTableComponent.prototype.extractRawValue = function (item, field, separator, returnLength) {
            var _this = this;
            if (separator === void 0) { separator = ', '; }
            if (returnLength === void 0) { returnLength = true; }
            if (field.indexOf('.') < 0) {
                if (item !== undefined && item.hasOwnProperty(field)) {
                    var data = item[field];
                    if (data instanceof Array) {
                        return returnLength ? data.length : data;
                    }
                    else {
                        return data;
                    }
                }
                else
                    return '';
            }
            var keyPath = field.split('.');
            var currentItem = item;
            for (var index in keyPath) {
                if (keyPath.hasOwnProperty(index)) {
                    var key = keyPath[index];
                    if (currentItem === undefined)
                        return "";
                    if (currentItem.hasOwnProperty(key)) {
                        currentItem = currentItem[key];
                        if (currentItem instanceof Array) {
                            var remainingKeyPath = keyPath.slice(+index + 1, keyPath.length).join(".");
                            var nested = new Array();
                            currentItem.forEach(function (element) {
                                nested.push(_this.extractRawValue(element, remainingKeyPath));
                            });
                            return nested.join(separator);
                        }
                    }
                    else
                        return "";
                }
            }
            if (currentItem instanceof Date) {
                return currentItem.toDateString();
            }
            if (currentItem instanceof Array) {
                return returnLength ? currentItem.length : currentItem;
            }
            return currentItem;
        };
        DataTableComponent.prototype.presentInsertForm = function () {
            this.onInsertFormRequested.emit();
        };
        DataTableComponent.prototype.getDeletedCondition = function (item, rowIndex) {
            var backgroundColor = (rowIndex % 2 == 0) ? "#f3f6f8" : 'transparent';
            if (this.containsNestedData == true) {
                backgroundColor = item === this.activeItem ? "#f3f6f8" : backgroundColor;
            }
            else {
                backgroundColor = (rowIndex == this.activeRow) ? "#f3f6f8" : backgroundColor;
            }
            if (item.hasOwnProperty("isDeleted") && item["isDeleted"] == true) {
                return { 'text-decoration': 'line-through', 'background-color': backgroundColor };
            }
            else if (item.hasOwnProperty("isActive") && item["isActive"] == false) {
                return { 'text-decoration': 'line-through', 'background-color': backgroundColor };
            }
            return { 'background-color': backgroundColor };
        };
        DataTableComponent.prototype.clickedOutside = function ($event) {
            this.closeContextMenu();
        };
        DataTableComponent.prototype.onWindowScroll = function (event) {
            this.closeContextMenu();
        };
        DataTableComponent.prototype.onScroll = function (event) {
            this.closeContextMenu();
        };
        DataTableComponent.prototype.onMouseWheel = function (event) {
            this.closeContextMenu();
        };
        DataTableComponent.prototype.toggleActionsDropdown = function (event, item) {
            event.preventDefault();
            event.stopPropagation();
            this.activeContextItem = item;
            if (event instanceof MouseEvent) {
                var relativeContainer = document.querySelector(".data-table-container[identifier='" + this.identifier + "']");
                var content = document.getElementById('action_menu_content_' + this.identifier);
                content.style.right = 'auto';
                content.style.bottom = 'auto';
                content.style.top = event.clientY - relativeContainer.getBoundingClientRect().top + "px";
                content.style.left = event.clientX - relativeContainer.getBoundingClientRect().left + 'px';
                var actionMenuContainer = document.getElementById('action_menu_container_' + this.identifier);
                if (actionMenuContainer) {
                    actionMenuContainer.classList.add('open');
                }
            }
        };
        DataTableComponent.prototype.closeContextMenu = function () {
            var actionMenuContainer = document.getElementById('action_menu_container_' + this.identifier);
            if (actionMenuContainer) {
                actionMenuContainer.classList.remove('open');
            }
        };
        DataTableComponent.prototype.exportPDF = function () {
            alert("PDF Export is not implemented yet.");
        };
        DataTableComponent.prototype.exportExcel = function () {
            this.exportItemsToExcel(this.items);
        };
        DataTableComponent.prototype.prepareItems = function (items) {
            var _this = this;
            var division = this.getDivisionColumns();
            items.forEach(function (item) {
                var rowCounts = new Array();
                division.forEach(function (column) {
                    if (column.divisionField !== undefined) {
                        var value = _this.extractRawValue(item, column.divisionField, ',', false);
                        if (value instanceof Array) {
                            var length = value.length > 0 ? value.length : 1;
                            item["_" + column.divisionField + "Count"] = length;
                            rowCounts.push(length);
                        }
                    }
                });
                var lcm = _this.range_lcm(rowCounts);
                item["_rowCount"] = lcm;
                item["_rowIterator"] = Array(lcm).fill(1);
            });
            this.renderItems(items);
        };
        // NestedDataStrategy
        // None = 0,
        // Concat = 1,
        // Divide = 2
        DataTableComponent.prototype.exportItemsToExcel = function (items) {
            var _this = this;
            if (items != undefined && items.length > 0) {
                this.prepareItems(items);
                var data = [];
                items.forEach(function (item) {
                    var row = new Object();
                    _this.activeColumns.forEach(function (column) {
                        var value = undefined;
                        if (column.type == 'condition') {
                            // Need excel template as well
                            value = column.getTemplate(item);
                            if (value != undefined) {
                                var regex = /(<([^>]+)>)/ig;
                                value = value.replace(regex, "");
                            }
                        }
                        else if (column.type == 'data') {
                            value = _this.extractValue(item, column);
                        }
                        else if (column.type === 'date') {
                            // Need pipe here, use the one below.
                            value = _this.extractValue(item, column);
                            //extractValue(item, column) | date:column.format
                        }
                        else if (column.isComputed) {
                            if (_this.computeProperyForItem !== undefined) {
                                value = _this.computeProperyForItem.call(_this.context, item, column.field);
                                var regex = /(<([^>]+)>)/ig;
                                value = value.replace(regex, "");
                            }
                        }
                        row[column.displayText] = value;
                    });
                    if (item._rowCount > 0) {
                        item._rowIterator.forEach(function (element, index) {
                            var innerRow = new Object();
                            Object.assign(innerRow, row);
                            _this.activeColumns.forEach(function (column) {
                                if (column.nestedDataStrategy > 0)
                                    innerRow[column.displayText] = item._render[column.field][index]['displayText'];
                            });
                            data.push(innerRow);
                        });
                    }
                    else {
                        data.push(row);
                    }
                });
                var opts = [{ sheeitd: "Sheet 1", header: true }];
                alasql.utils.isBrowserify = false;
                alasql.utils.global.XLSX = XLSX;
                alasql("SELECT INTO XLSX ('Export.xlsx',?) FROM ?", [opts, [data]]);
            }
        };
        /*
         
            let DataForSheet1: any[] = [];
            DataForSheet1.push({ FName: "John", LName: "Kennedy" });
            DataForSheet1.push({ FName: "Ajay", LName: "Kumar" });
            DataForSheet1.push({ FName: "Deepak", LName: "Reddy" });
            DataForSheet1.push({ FName: "Kiran", LName: "Kumar" });
         
            let DataForSheet2: any[] = [];
            DataForSheet2.push({ Name: "John", Mark: 100 });
            DataForSheet2.push({ Name: "Ajay", LName: 85 });
            DataForSheet2.push({ Name: "Deepak", LName: 70 });
            DataForSheet2.push({ Name: "Kiran", LName: 90 });
         
            var opts = [{ sheeitd: "Sheet 1", header: true }, { sheeitd: "Sheet 2", header: true }]
         
        alasql['utils'].isBrowserify = false;
        alasql['utils'].global.XLSX = XLSX;
         
            alasql("SELECT INTO XLSX ('Students.xlsx',?) FROM ?", [opts, [DataForSheet1, DataForSheet2]]);
        //This piece of code will download excel sheet with two sheets
         
            alasql("SELECT TOP 2 Name as [Student Name], Mark as [Subject Marks] INTO XLSX ('Marks.xlsx',{headers:true}) FROM ?", [DataForSheet2]);
        //This piece of code will download excel sheet with one sheet, and if you notice here we could change the column name also.
         
        //
         
         
        */
        DataTableComponent.prototype.toggleScroll = function () {
            this.isScrollable = !this.isScrollable;
            this.dataTableStorage.isScrollable = this.isScrollable;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
        };
        DataTableComponent.prototype.toggleCompactMode = function () {
            this.isCompressed = !this.isCompressed;
            this.dataTableStorage.isCompressed = this.isCompressed;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
        };
        DataTableComponent.prototype.toggleSize = function (event) {
            this.isFullScreen = !this.isFullScreen;
            this.dataTableStorage.isFullScreen = this.isFullScreen;
            LocalStorageHandler.setDataTableSettings(this.dataTableStorage);
            var eventTarget = event.target;
            if (eventTarget !== undefined && eventTarget !== null) {
                var container = eventTarget.closest(this.isFullScreen ? '.container' : '.container-fluid');
                if (container !== undefined && container !== null) {
                    if (!container.classList.contains('margin-t-10')) {
                        container.classList.add('margin-t-10');
                    }
                    container.classList.remove(this.isFullScreen ? 'container' : 'container-fluid');
                    container.classList.add(this.isFullScreen ? 'container-fluid' : 'container');
                }
            }
        };
        DataTableComponent.prototype.itemClicked = function (item) {
            if (this.rowSelectionEnabled == true) {
                item._selected = !item._selected;
                // TODO : Check for multiple event triggers.
                this.onSelectionChanged.emit(this.getSelectedItems());
            }
        };
        DataTableComponent.prototype.getSelectedItems = function () {
            return this.items.filter(function (x) { return x._selected == true; });
        };
        DataTableComponent.prototype.checkedChanged = function (item) {
            var selectedItems = this.getSelectedItems();
            this.onSelectionChanged.emit(selectedItems);
            this.itemSelectionChanged = true;
            this.allSelected = selectedItems.length == this.items.length;
        };
        DataTableComponent.prototype.toggleAllSelection = function () {
            var _this = this;
            if (this.itemSelectionChanged) {
                this.itemSelectionChanged = false;
                return;
            }
            this.items.forEach(function (item) { item._selected = _this.allSelected; });
        };
        DataTableComponent.prototype.onRightClick = function ($event, item) {
            this.toggleActionsDropdown($event, item);
            return false;
        };
        DataTableComponent.prototype.toggleOptionsMenu = function () {
            this.optionsMenuVisible = !this.optionsMenuVisible;
        };
        DataTableComponent.prototype.closeOptionsMenu = function () {
            this.optionsMenuVisible = false;
        };
        DataTableComponent.prototype.shiftColumn = function (column, shift) {
            var index = this.columns.indexOf(column);
            var targetIndex = index + shift;
            this.columns[index] = this.columns[targetIndex];
            this.columns[targetIndex] = column;
            this.setActiveColumns();
        };
        DataTableComponent.prototype.activeColumnConfigChanged = function () {
            this.setActiveColumns();
        };
        // Returns true if selection changed, false if not. Undefined if configuration is not set.
        DataTableComponent.prototype.columnSelected = function (row, column, item) {
            if (this.rowCount === undefined || this.columnCount === undefined) {
                return undefined;
            }
            this.activeItem = item;
            if (!this.rowSelected(row) && this.activeColumn == column)
                return false;
            this.activeColumn = column;
            this.onColumnSelected.emit(this.activeColumn);
        };
        // Returns true if selection changed, false if not. Undefined if configuration is not set
        DataTableComponent.prototype.rowSelected = function (row) {
            if (this.rowCount === undefined || this.columnCount === undefined) {
                return undefined;
            }
            if (this.activeRow == row)
                return false;
            this.activeRow = row;
            this.onRowSelected.emit(this.activeRow);
            this.onEntitySelected.emit(this.items[this.activeRow]);
            return true;
        };
        DataTableComponent.prototype.keyboardInput = function ($event) {
            var code = event["code"];
            if (code == "ArrowRight" || code == "ArrowLeft" || code == "ArrowUp" || code == "ArrowDown" || code == "Space") {
                if (code == "Space") {
                    this.activeColumn = this.columnToBeSelected;
                    this.activeRow = this.rowToBeSelected;
                    this.rowToBeSelected = undefined;
                    this.columnToBeSelected = undefined;
                    return;
                }
                var currentRow = (this.rowToBeSelected != undefined) ? this.rowToBeSelected : ((this.activeRow != undefined) ? this.activeRow : 0);
                var currentColumn = (this.columnToBeSelected != undefined) ? this.columnToBeSelected : ((this.activeColumn != undefined) ? this.activeColumn : 0);
                if (code == "ArrowRight") {
                    currentColumn = currentColumn + 1;
                }
                else if (code == "ArrowLeft") {
                    currentColumn = currentColumn - 1;
                }
                else if (code == "ArrowUp") {
                    currentRow = currentRow - 1;
                }
                else if (code == "ArrowDown") {
                    currentRow = currentRow + 1;
                }
                currentRow = Math.max(0, currentRow);
                currentColumn = Math.max(0, currentColumn);
                currentRow = Math.min(currentRow, this.rowCount - 1);
                currentColumn = Math.min(currentColumn, this.columnCount - 1);
                this.rowToBeSelected = currentRow;
                this.columnToBeSelected = currentColumn;
                event.preventDefault();
                event.stopPropagation();
            }
            // ArrowRight
            // ArrowLeft
            // ArrowUp
            // ArrowDown
            // this.keyboardEvent = event;
            // this.altKey = event.altKey;
            // this.charCode = event.charCode;
            // this.code = event.code;
            // this.ctrlKey = event.ctrlKey;
            // this.keyCode = event.keyCode;
            // this.keyIdentifier = event.keyIdentifier;
            // this.metaKey = event.metaKey;
            // this.shiftKey = event.shiftKey;
            // this.timeStamp = event.timeStamp;
            // this.type = event.type;
            // this.which = event.which;
        };
        // End of keyboard actions.
        // Euclid algorithm for Greates Common Divisor
        DataTableComponent.prototype.gcd = function (a, b) {
            return !b ? a : this.gcd(b, a % b);
        };
        // Least Common Multiple function
        DataTableComponent.prototype.lcm = function (a, b) {
            return a * (b / this.gcd(a, b));
        };
        // LCM of all numbers in the range of arr=[a, b]
        DataTableComponent.prototype.range_lcm = function (arr) {
            var _this = this;
            var result = arr[0];
            arr.forEach(function (element) {
                result = _this.lcm(result, element);
            });
            return result;
        };
        DataTableComponent.prototype.setPredefinedFilter = function (filter) {
            if (filter != undefined && filter.length > 0) {
                this.dataTableStorage = DataTableStorageModel.parse(JSON.parse(filter));
                this.changeFilterState();
                this.setDataTableSettings(this.dataTableStorage, false);
            }
        };
        DataTableComponent.prototype.turnDefaultFilterActionClicked = function () {
            var dtSetting = LocalStorageHandler.removeDataTableFilter(this.dataTableID);
            this.setDataTableSettings(dtSetting);
        };
        DataTableComponent.prototype.editUserDefinedFilterActionClicked = function (userDefinedFilter) {
            userDefinedFilter.selected = true;
            this.activeUserDefinedFilter = userDefinedFilter.owner;
            this.filterManagementPageMode = FilterManagementPageMode.Update;
        };
        DataTableComponent.prototype.addNewFilterButtonClicked = function () {
        };
        DataTableComponent.prototype.cancelUserDefinedFilterActionClicked = function (userDefinedFilter) {
            if (this.filterManagementPageMode == FilterManagementPageMode.Insert) {
                var index = this.userDefinedFilters.indexOf(userDefinedFilter);
                if (index > -1)
                    this.userDefinedFilters.splice(index, 1);
            }
            this.userDefinedFilters.map(function (x) { return x.selected = false; });
            this.activeUserDefinedFilter = undefined;
            this.filterManagementPageMode = FilterManagementPageMode.List;
        };
        DataTableComponent.prototype.activateActionClicked = function (userDefinedFilter) {
        };
        DataTableComponent.prototype.setUserDefinedFilters = function (filters) {
        };
        DataTableComponent.prototype.selectedUserDefinedFilterChange = function (event) {
            if (event != undefined && event.length > 0 && event[0] != undefined) {
                this.onUserDefinedFilterSelected.emit(event[0].value);
                // let userDefinedFilter = event[0].owner;
                // this.dataTableStorage = DataTableStorageModel.parse(JSON.parse(userDefinedFilter.filterJson));
                // this.changeFilterState();
                // this.setDataTableSettings(this.dataTableStorage);
            }
        };
        DataTableComponent.prototype.editTable = function () {
            var navigationExtras = { relativeTo: this.route, state: { 'tableConfig': this.tableConfig, 'configPath': this.configPath } };
            this.router.navigate(['/administration/data-table-editor'], navigationExtras);
        };
        DataTableComponent.prototype.openFilterPopup = function (userDefinedFilterPopupTemplate) {
            this.tableSettingMode = TableSettingMode.FilterManagement;
            // var dialogRef = this.dialog.open(userDefinedFilterPopupTemplate, { panelClass: 'modal-dialog' });
        };
        DataTableComponent.prototype.switchTableSettingMode = function () {
            this.tableSettingMode = this.tableSettingMode == TableSettingMode.FilterManagement ? TableSettingMode.Default : TableSettingMode.FilterManagement;
        };
        DataTableComponent.prototype.deleteUserDefinedFilterActionClicked = function (userDefinedFilter) {
            // this.startProgress("");
            // this.userDefinedFilterRepo.delete(userDefinedFilter.value)
            //   .then(response => {
            //     if (!response.hasError()) {
            //       let index = this.userDefinedFilters.indexOf(userDefinedFilter);
            //       if (index > -1)
            //         this.userDefinedFilters.splice(index, 1);
            //       this.successMessage = "İşlem başarılı bir şekilde tamamlandı.";
            //       this.filterManagementPageMode = FilterManagementPageMode.List;
            //       this.stopProgress();
            //     } else {
            //       this.hasError = true;
            //       this.errorMessage = response.getFirstErrorMessage();
            //       this.stopProgress();
            //     }
            //   })
            //   .catch(error => {
            //     this.hasError = true;
            //     this.errorMessage = `Sunucuyla bağlantı kurulurken hata oluştu. Lütfen tekrar deneyiniz. Hata detayı: ${error}`;
            //     this.stopProgress();
            //   });
        };
        DataTableComponent.prototype.saveUserDefinedFilter = function () {
            // if (!this.activeUserDefinedFilter.name) {
            //   this.errorMessage = "Filtre adı boş bırakılamaz";
            //   return;
            // }
            // let request: Promise<ResponseModel<UserDefinedFilterModel>>;
            // if (!this.activeUserDefinedFilter.id) {
            //   this.activeUserDefinedFilter.filterJson = JSON.stringify(this.dataTableStorage);
            //   this.activeUserDefinedFilter.userID = +LocalStorageHandler.getUserId();
            //   this.activeUserDefinedFilter.dataTableID = this.dataTableID;
            //   request = this.userDefinedFilterRepo.post(
            //     this.activeUserDefinedFilter
            //   );
            // } else if (this.activeUserDefinedFilter.id) {
            //   request = this.userDefinedFilterRepo.put(
            //     this.activeUserDefinedFilter
            //   );
            // }
            // this.startProgress("");
            // request
            //   .then(response => {
            //     if (!response.hasError()) {
            //       let foundItem: FilterItem;
            //       if (!this.activeUserDefinedFilter.id)
            //         foundItem = this.userDefinedFilters.find(x => !x.value);
            //       else
            //         foundItem = this.userDefinedFilters.find(x => x.value == this.activeUserDefinedFilter.id);
            //       let index = this.userDefinedFilters.indexOf(foundItem);
            //       if (index > -1)
            //         this.userDefinedFilters.splice(index, 1);
            //       this.userDefinedFilters.push(response.entity.asFilterItem(response.entity));
            //       this.successMessage = "İşlem başarılı bir şekilde tamamlandı.";
            //       this.filterManagementPageMode = FilterManagementPageMode.List;
            //       this.stopProgress();
            //     } else {
            //       this.hasError = true;
            //       this.errorMessage = response.getFirstErrorMessage();
            //       this.stopProgress();
            //     }
            //   })
            //   .catch(error => {
            //     this.hasError = true;
            //     this.errorMessage = `Sunucuyla bağlantı kurulurken hata oluştu. Lütfen tekrar deneyiniz. Hata detayı: ${error}`;
            //     this.stopProgress();
            //   });
        };
        DataTableComponent.prototype.saveTableSettings = function () {
            // if (!this.userDefinedFilter.name) {
            //   this.errorMessage = "Ad boş bırakılamaz";
            //   return;
            // }
            // this.userDefinedFilter.filterJson = JSON.stringify(this.dataTableStorage);
            // this.userDefinedFilter.userID = +LocalStorageHandler.getUserId();
            // this.userDefinedFilter.dataTableID = this.dataTableID;
            // const request = this.userDefinedFilterRepo.post(
            //   this.userDefinedFilter
            // );
            // this.startProgress("");
            // request
            //   .then(response => {
            //     if (!response.hasError()) {
            //       this.userDefinedFilter = response.entity;
            //       this.successMessage = "İşlem başarılı bir şekilde tamamlandı.";
            //       this.dialog.closeAll();
            //       this.stopProgress();
            //     } else {
            //       this.hasError = true;
            //       this.errorMessage = response.getFirstErrorMessage();
            //       this.stopProgress();
            //     }
            //   })
            //   .catch(error => {
            //     this.hasError = true;
            //     this.errorMessage = `Sunucuyla bağlantı kurulurken hata oluştu. Lütfen tekrar deneyiniz. Hata detayı: ${error}`;
            //     this.stopProgress();
            //   });
        };
        DataTableComponent.prototype.getUserDefinedFilters = function () {
            // let userID = +LocalStorageHandler.getUserId();
            // if (!userID) {
            //   return;
            // }
            // let searchCriteria = new SearchCriteria();
            // searchCriteria.key = "DataTableID";
            // searchCriteria.value = [this.dataTableID];
            // this.startProgress("");
            // this.userDefinedFilterRepo.getByUser(userID, 0, 0, false, [searchCriteria])
            //   .then(response => {
            //     if (!response.hasError()) {
            //       this.userDefinedFilters = response.entities.asFilter();
            //       this.filterManagementPageMode = FilterManagementPageMode.List;
            //       this.stopProgress();
            //     } else {
            //       this.hasError = true;
            //       this.errorMessage = response.getFirstErrorMessage();
            //       this.stopProgress();
            //     }
            //   })
            //   .catch(error => {
            //     this.hasError = true;
            //     this.errorMessage = `Sunucuyla bağlantı kurulurken hata oluştu. Lütfen tekrar deneyiniz. Hata detayı: ${error}`;
            //     this.stopProgress();
            //   });
        };
        DataTableComponent.prototype.showCommentsButtonClicked = function (item) {
            // const dialogRef = this.dialog.open(CommentComponent, { panelClass: 'modal-dialog' });
            // dialogRef.componentInstance.sourceGuid = item.rowguid;
            // dialogRef.componentInstance.sourceId = 2;
            // dialogRef.componentInstance.showLikeButton = true;
            // dialogRef.afterClosed().subscribe(result => {
            // });
        };
        DataTableComponent.prototype.showDocumentsButtonClicked = function (item) {
            // const dialogRef = this.dialog.open(DocumentListByownerComponent, { panelClass: 'modal-dialog' });
            // dialogRef.componentInstance.ownerID = item.rowguid;
            // dialogRef.componentInstance.viewSizeMode = 1; 
        };
        DataTableComponent.ctorParameters = function () { return [
            { type: dialog.MatDialog },
            { type: router.Router },
            { type: router.ActivatedRoute /*, private userDefinedFilterRepo: UserDefinedFilterRepository*/ }
        ]; };
        __decorate([
            core.ViewChildren('dataTableFilters')
        ], DataTableComponent.prototype, "dataTableFilters", void 0);
        __decorate([
            core.ViewChild('pager')
        ], DataTableComponent.prototype, "pager", void 0);
        __decorate([
            core.ViewChild('tableContainer')
        ], DataTableComponent.prototype, "tableContainer", void 0);
        __decorate([
            core.ViewChild('actionsContainer')
        ], DataTableComponent.prototype, "actionsContainer", void 0);
        __decorate([
            core.Input()
        ], DataTableComponent.prototype, "dataTableID", null);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onConfigurationLoaded", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onFilterUpdated", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onSortPreferenceChanged", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onGroupPreferenceChanged", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onPageChanged", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onPageCountChanged", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onUserDefinedFilterSelected", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onInsertFormRequested", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onEntitySelected", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onRowSelected", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onColumnSelected", void 0);
        __decorate([
            core.Output()
        ], DataTableComponent.prototype, "onSelectionChanged", void 0);
        __decorate([
            core.HostListener('document:click', ['$event'])
        ], DataTableComponent.prototype, "clickedOutside", null);
        __decorate([
            core.HostListener('window:scroll', ['$event'])
        ], DataTableComponent.prototype, "onWindowScroll", null);
        __decorate([
            core.HostListener('scroll', ['$event'])
        ], DataTableComponent.prototype, "onScroll", null);
        __decorate([
            core.HostListener('mousewheel', ['$event'])
        ], DataTableComponent.prototype, "onMouseWheel", null);
        DataTableComponent = __decorate([
            core.Component({
                selector: 'data-table',
                template: "<div class=\"data-table-container\" [attr.identifier]=\"identifier\" style=\"position:relative\">\r\n\r\n  <!--<div class=\"input-icon right\" style=\"float:right;margin:20px 0px\">\r\n  <i class=\"icon-magnifier\"></i>\r\n  <input class=\"form-control form-control-solid input-circle\" placeholder=\"Ara\" [(ngModel)]=\"searchTerm\" (ngModelChange)=\"generalSearchInputChanged($event)\"\r\n  /> </div>-->\r\n  <!-- <div class=\"actions-overlay\" *ngIf=\"selectedAction !== undefined\" (click)=\"toggleActionsDropdown()\"></div> -->\r\n\r\n  <div *ngIf=\"optionsMenuVisible\" class=\"dropdown-menu\"\r\n    style=\"position:absolute; left:auto; right: 30px; top: 30px; display:inline !important;\">\r\n    <div style=\"padding:15px 10px 10px 15px;\">\r\n      <span class=\"pull-left caption-subject font-semi-bold\">\r\n        <ng-template [ngIf]=\"tableSettingMode == 1\">\r\n          Tablo Ayarlar\u0131\r\n        </ng-template>\r\n        <ng-template [ngIf]=\"tableSettingMode == 2\">\r\n          Filtre Y\u00F6netimi\r\n        </ng-template>\r\n      </span>\r\n      <a class=\"fa\" (click)=\"closeOptionsMenu()\" class=\"pull-right\" style=\"font-size:20px\">\r\n        <i class=\"fa fa-remove pull-right\" matTooltip=\"Kapat\" matTooltipPosition=\"above\"></i>\r\n      </a>\r\n      <div class=\"clearfix\"></div>\r\n    </div>\r\n    <ng-template [ngIf]=\"tableSettingMode == 1\">\r\n      <ul class=\"list-group\" style=\"max-height: 300px;margin-bottom: 10px;overflow:scroll;-webkit-overflow-scrolling: touch; border-radius: 0px;overflow-y: scroll;\r\n        overflow-x: hidden;\">\r\n        <li class=\"list-group-item\">\r\n          <!-- <a class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"exportPDF()\">\r\n          <i class=\"fa fa-file-pdf-o\"></i>\r\n        </a>-->\r\n          <a *ngIf=\"isAdmin == true\" class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"editTable()\"\r\n            matTooltip=\"D\u00FCzenle\" matTooltipPosition=\"above\">\r\n            <i class=\"fa fa-pencil\"></i>\r\n          </a>\r\n          <a class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"exportExcel()\" [matTooltip]=\"'Excel indir'\"\r\n            matTooltipPosition=\"above\">\r\n            <i class=\"fa fa-file-excel-o\"></i>\r\n          </a>\r\n          <a class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"toggleSize($event)\"\r\n            [matTooltip]=\"isFullScreen ? 'S\u0131k\u0131\u015Ft\u0131r(Yatay)' : 'Geni\u015Flet(Yatay)'\" matTooltipPosition=\"above\">\r\n            <i [ngClass]=\"isFullScreen ? 'icon-magnifier-remove': 'icon-magnifier-add'\"></i>\r\n          </a>\r\n          <a class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"toggleScroll()\"\r\n            [matTooltip]=\"isScrollable ? 'A\u015Fa\u011F\u0131 Uzat' : 'A\u015Fa\u011F\u0131 Uzatma(Scroll)'\" matTooltipPosition=\"above\">\r\n            <i [ngClass]=\"isScrollable ? 'fa fa-arrows-v': 'fa fa-lock'\"></i>\r\n          </a>\r\n          <a class=\"pull-left magnifier\" style=\"margin-right:10px\" (click)=\"toggleCompactMode()\"\r\n            [matTooltip]=\"isCompressed ? 'Geni\u015Flet(Dikey)' : 'S\u0131k\u0131\u015Ft\u0131r(Dikey)'\" matTooltipPosition=\"above\">\r\n            <i [ngClass]=\"isCompressed ? 'fa fa-compress': 'fa fa-expand'\"></i>\r\n          </a>\r\n          <div class=\"clearfix\"></div>\r\n        </li>\r\n        <ng-template ngFor let-column [ngForOf]=\"columns\" let-i=\"index\">\r\n          <li class=\"list-group-item\">\r\n            <div class=\"pull-left\">\r\n              <app-checkbox [margin]=\"0\" [(checked)]=\"column.isActive\" [label]=\"column.displayText\"\r\n                (checkedChange)=\"activeColumnConfigChanged()\"></app-checkbox>\r\n            </div>\r\n            <div class=\"pull-right\">\r\n              <a *ngIf=\"i > 0\" class=\"fa\" (click)=\"shiftColumn(column, -1)\" class=\"pull-rigt\" style=\"font-size:20px\">\r\n                <i class=\"fa fa-chevron-up pull-right\" style=\"margin-top:10px;\"></i>\r\n              </a>\r\n              <a *ngIf=\"i < columns.length -1\" class=\"fa\" (click)=\"shiftColumn(column, 1)\" class=\"pull-rigt\"\r\n                style=\"font-size:20px\">\r\n                <i class=\"fa fa-chevron-down pull-right\" style=\"margin-top:10px;\"></i>\r\n              </a>\r\n            </div>\r\n            <div class=\"clearfix\"></div>\r\n          </li>\r\n        </ng-template>\r\n      </ul>\r\n    </ng-template>\r\n    <ng-template [ngIf]=\"tableSettingMode == 2\">\r\n      <ul class=\"list-group\"\r\n        style=\"max-height: 300px;margin-bottom: 10px;margin-left:10px;overflow:scroll;-webkit-overflow-scrolling: touch; border-radius: 0px\">\r\n\r\n        <ng-template [ngIf]=\"postInProgress == true\">\r\n          <div class=\"lds-roller\">\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n            <div></div>\r\n          </div>\r\n        </ng-template>\r\n\r\n        <ng-template [ngIf]=\"postInProgress == false\">\r\n          <ng-template [ngIf]=\"!userDefinedFilters || userDefinedFilters?.length == 0\">\r\n            <p style=\"margin-top: 10px; margin-bottom: 0 !important\" class=\"text-center font-red\">Herhangi bir kay\u0131t\r\n              bulunamam\u0131\u015Ft\u0131r</p>\r\n          </ng-template>\r\n          <ng-template ngFor let-userDefinedFilter [ngForOf]=\"userDefinedFilters\" let-i=\"index\">\r\n            <ng-template [ngIf]=\"userDefinedFilters?.length > 0\">\r\n              <li class=\"list-group-item\" style=\"display: flex\">\r\n                <ng-template [ngIf]=\"!userDefinedFilter.selected\">\r\n                  {{ userDefinedFilter?.key }}\r\n                </ng-template>\r\n                <div style=\"position: absolute; right: 10px; top: 15px\">\r\n                  <ng-template [ngIf]=\"filterManagementPageMode == 0 && !userDefinedFilter.selected\">\r\n                    <a (click)=\"editUserDefinedFilterActionClicked(userDefinedFilter)\" matTooltip=\"D\u00FCzenle\"\r\n                      matTooltipPosition=\"above\"> <i class=\"fa fa-pencil\"></i> </a>\r\n                  </ng-template>\r\n                  <ng-template [ngIf]=\"filterManagementPageMode == 0 && !userDefinedFilter.selected\">\r\n                    <a (click)=\"deleteUserDefinedFilterActionClicked(userDefinedFilter)\" matTooltip=\"Sil\"\r\n                      matTooltipPosition=\"above\"> <i class=\"fa fa-trash font-red\"></i> </a>\r\n                  </ng-template>\r\n                  <ng-template\r\n                    [ngIf]=\"(filterManagementPageMode == 1 || filterManagementPageMode == 2) && userDefinedFilter.selected == true\">\r\n                    <a (click)=\"saveUserDefinedFilter()\" style=\"margin-top: 7px\"> <i class=\"fa fa-check font-green\"\r\n                        matTooltip=\"Kaydet\" matTooltipPosition=\"above\"></i> </a>\r\n                    <a (click)=\"cancelUserDefinedFilterActionClicked(userDefinedFilter)\" style=\"margin-top: 7px\"\r\n                      matTooltip=\"Vazge\u00E7\" matTooltipPosition=\"above\"> <i class=\"fa fa-times font-red\"></i> </a>\r\n                  </ng-template>\r\n                  <ng-template\r\n                    [ngIf]=\"filterManagementPageMode == 0 && !userDefinedFilter.selected && userDefinedFilter.activated == false\">\r\n                    <a (click)=\"activateActionClicked(userDefinedFilter)\" style=\"margin-left: 5px\">Etkinle\u015Ftir</a>\r\n                  </ng-template>\r\n                  <ng-template\r\n                    [ngIf]=\"filterManagementPageMode == 0 && !userDefinedFilter.selected && userDefinedFilter.activated == true\">\r\n                    <span class=\"label label-success\" style=\"margin-left: 5px\">Etkin</span>\r\n                  </ng-template>\r\n                </div>\r\n                <ng-template\r\n                  [ngIf]=\"(filterManagementPageMode == 1 || filterManagementPageMode == 2) && userDefinedFilter.selected == true\">\r\n                  <input type=\"text\" class=\"form-control\" [(ngModel)]=\"activeUserDefinedFilter.name\"\r\n                    placeholder=\"Filtre Ad\u0131\" style=\"width: 75%\">\r\n                </ng-template>\r\n              </li>\r\n            </ng-template>\r\n          </ng-template>\r\n        </ng-template>\r\n      </ul>\r\n    </ng-template>\r\n    <!-- <ng-template [ngIf]=\"onUserDefinedFilterSelected.observers.length > 0\"> -->\r\n\r\n    <ng-template [ngIf]=\"tableSettingMode == 1\">\r\n      <div class=\"form-group\">\r\n        <button class=\"btn btn-default btn-sm btn-block pull-right\" (click)=\"switchTableSettingMode()\">\r\n          Filtre Y\u00F6netimi\r\n        </button>\r\n      </div>\r\n    </ng-template>\r\n\r\n    <div class=\"form-inline\" style=\"margin: 10px\">\r\n      <ng-template [ngIf]=\"tableSettingMode == 2\">\r\n        <div class=\"form-group\">\r\n          <button class=\"btn btn-default btn-sm btn-block pull-right\" (click)=\"switchTableSettingMode()\">\r\n            <i class=\"fa fa-chevron-left\"></i> Geri D\u00F6n\r\n          </button>\r\n        </div>\r\n      </ng-template>\r\n\r\n      <ng-template [ngIf]=\"tableSettingMode == 2 && filterManagementPageMode == 0\">\r\n        <div class=\"form-group\">\r\n          <button class=\"btn btn-success btn-sm btn-block pull-right\" (click)=\"turnDefaultFilterActionClicked()\">\r\n            Varsay\u0131lana D\u00F6n\r\n          </button>\r\n        </div>\r\n        <div class=\"form-group\">\r\n          <button class=\"btn btn-primary btn-sm btn-block pull-right\" (click)=\"addNewFilterButtonClicked()\">\r\n            Yeni Ekle\r\n          </button>\r\n        </div>\r\n\r\n      </ng-template>\r\n    </div>\r\n    <!-- </ng-template> -->\r\n  </div>\r\n\r\n  <div class=\"table-container\" [class.hidden]=\"loading || !enabled\" [class.has-actions]=\"columnActions\">\r\n    <div class=\"table-column\">\r\n      <!-- <ng-scrollbar [trackY]=\"false\" [trackX]=\"true\" [autoHide]=\"true\" thumbClass=\"bar-bottom\"> -->\r\n      <div style=\"margin-top:0 !important\" class=\"table-responsive dafaque\" [class.table-scroll-enabled]=\"isScrollable\"\r\n        [class.table-scroll-disabled]=\"!isScrollable\" [class.table-nowrap]=\"isCompressed\" #tableContainer>\r\n        <div *ngFor=\"let column of activeColumns\">\r\n          <button *ngIf=\"column.grouped\">{{column.displayText}}</button>\r\n        </div>\r\n        <table class=\"table application-data-table\">\r\n          <thead>\r\n            <tr>\r\n              <th *ngIf=\"uiSelectionEnabled\"></th>\r\n              <th *ngFor=\"let column of activeColumns\">\r\n                <div>\r\n                  <h4>{{ column.displayText }}</h4>\r\n                  <a *ngIf=\"column.supportsSorting\" class=\"margin-l-5 pull-left padding-t-10\" (click)=\"sort(column)\">\r\n                    <i *ngIf=\"column.sortDirection == 0\" class=\"fa fa-sort-desc\"></i>\r\n                    <i *ngIf=\"column.sortDirection == 1\" class=\"fa fa-sort-asc\"></i>\r\n                    <i *ngIf=\"column.sortDirection == 2\" class=\"fa fa-sort\"></i>\r\n                  </a>\r\n                  <a *ngIf=\"column.supportsGrouping\" class=\"margin-r-5 pull-right font-dark padding-t-10\"\r\n                    (click)=\"group(column)\">\r\n                    <i class=\"fa fa-link\"></i>\r\n                  </a>\r\n                </div>\r\n              </th>\r\n              <th *ngIf=\"commentsEnabled\"></th>\r\n              <th *ngIf=\"documentsEnabled\"></th>\r\n              <th class=\"sticky-column-with-fake-border\" style=\"text-align:center;min-width: 50px;\">\r\n                <i (click)=\"toggleOptionsMenu()\" class=\"pe-7s-keypad\" aria-hidden=\"true\"\r\n                  style=\"font-size:24px;color:#4a4a4a; margin-top:8px; cursor:pointer;\" matTooltip=\"Ayarlar\u0131 uygula\"\r\n                  matTooltipPosition=\"above\"></i>\r\n                <!-- <h4 class=\"hidden-xs\"> {{actionColumn.displayText}} </h4> -->\r\n                <!-- <h4 class=\"visible-xs\"> {{actionColumn.displayText | truncate: 4}} </h4> -->\r\n              </th>\r\n              <th></th>\r\n            </tr>\r\n          </thead>\r\n          <tbody>\r\n            <tr *ngIf=\"columnFilterEnabled\" class=\"filter-row\">\r\n              <td *ngIf=\"uiSelectionEnabled\">\r\n                <app-checkbox [(checked)]=\"allSelected\" (checkedChange)=\"toggleAllSelection()\"></app-checkbox>\r\n              </td>\r\n              <td *ngFor=\"let column of activeColumns\">\r\n                <data-table-filter #dataTableFilters *ngIf=\"column.filterEnabled == true\" [(filter)]=\"column.filter\"\r\n                  (onFilterChanged)=\"onFilterChanged()\" (comboboxItemsLoaded)=\"changeFilterState()\">\r\n                </data-table-filter>\r\n                <ng-template [ngIf]=\"column.filterEnabled == false\">\r\n                  <!-- {{ 'MESSAGES.filteringDisabled' | translate }} -->\r\n                </ng-template>\r\n              </td>\r\n              <td *ngIf=\"commentsEnabled\"></td>\r\n              <td *ngIf=\"documentsEnabled\"></td>\r\n              <td class=\"sticky-column-with-fake-border\">\r\n                <div>\r\n                  <a matTooltip=\"Filtreleri Temizle\" matTooltipPosition=\"above\" class=\"clear-filters\"\r\n                    [ngClass]=\"{ 'hidden': !hasFilters }\" (click)=\"clearFilters()\">\r\n                    <i class=\"iconx-remove-filter font-red-haze\"></i>\r\n                  </a>\r\n                </div>\r\n              </td>\r\n            </tr>\r\n            <ng-template [ngIf]=\"containsNestedData == true\">\r\n              <ng-template ngFor let-item [ngForOf]=\"items\" let-rowIndex=\"index\">\r\n                <tr *ngFor=\"let row of item._rowIterator; let i=index\" [ngStyle]=\"item?._render?._deletedCondition\"\r\n                  (dblclick)=\"itemClicked(item)\" (contextmenu)=\"onRightClick($event, item)\">\r\n                  <td [rowSpan]=\"item._rowCount\" *ngIf=\"item._render._uiSelectionEnabled[i]\">\r\n                    <app-checkbox [(checked)]=\"item._selected\" (checkedChange)=\"checkedChanged(item)\"></app-checkbox>\r\n                  </td>\r\n                  <ng-template ngFor let-column [ngForOf]=\"activeColumns\" let-columnIndex=\"index\">\r\n                    <ng-template [ngIf]=\"column.nestedDataStrategy == 2\">\r\n                      <td [rowSpan]=\"item._render[column.field][i]['rowSpan']\"\r\n                        *ngIf=\"item._render[column.field][i]['rowSpanEnabled']\"\r\n                        (click)=\"columnSelected(rowIndex, columnIndex, item)\"\r\n                        [ngStyle]=\"{'min-width':  column.minWidth ? column.minWidth: '75px','background-color':  ((item == activeItem) && (columnIndex == activeColumn)) ? '#d3dbe9': 'transparent', 'border': ((rowIndex == rowToBeSelected) && (columnIndex == columnToBeSelected)) ? '1px dashed black': '1px solid #e7ecf1'}\">\r\n                        <ng-template [ngIf]=\"column.type == 'condition'\">\r\n                          <div [innerHTML]=\"item._render['_template_' + column.index]\"></div>\r\n                        </ng-template>\r\n                        <ng-template [ngIf]=\"column.type == 'html'\">\r\n                          <div [innerHTML]=\"item._render[column.field]\"></div>\r\n                        </ng-template>\r\n                        <ng-template [ngIf]=\"column.type != 'condition'\">\r\n                          {{item._render[column.field][i]['displayText']}}</ng-template>\r\n\r\n                        <ng-template [ngIf]=\"column.type == 'multimedia'\">\r\n                          <img src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" class=\"media-object\"\r\n                            width=\"200px;\" />\r\n                        </ng-template>\r\n\r\n                        <ng-template [ngIf]=\"column.type == 'video'\">\r\n                          <video width=\"200\" height=\"200\" controls>\r\n                            <source src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" type=\"video/mp4\">\r\n                            Your browser does not support the video tag.\r\n                          </video>\r\n                        </ng-template>\r\n                      </td>\r\n                    </ng-template>\r\n                    <ng-template [ngIf]=\"column.nestedDataStrategy != 2\">\r\n                      <td [rowSpan]=\"item._rowCount\" *ngIf=\"item._render._tdVisible[i]\"\r\n                        (click)=\"columnSelected(rowIndex, columnIndex, item)\"\r\n                        [ngStyle]=\"{'min-width':  column.minWidth ? column.minWidth: '75px','background-color':  ((rowIndex == activeRow) && (columnIndex == activeColumn)) ? '#d3dbe9': 'transparent', 'border': ((rowIndex == rowToBeSelected) && (columnIndex == columnToBeSelected)) ? '1px dashed black': '1px solid #e7ecf1'}\">\r\n                        <ng-template [ngIf]=\"column.type == 'condition'\">\r\n                          <div [innerHTML]=\"item._render['_template_' + column.index]\"></div>\r\n                        </ng-template>\r\n                        <ng-template [ngIf]=\"column.type == 'html'\">\r\n                          <div [innerHTML]=\"item._render[column.field]\"></div>\r\n                        </ng-template>\r\n                        <ng-template [ngIf]=\"column.type == 'data' || column.type == 'date'\">\r\n                          {{item._render[column.field]}}\r\n                        </ng-template>\r\n\r\n                        <ng-template [ngIf]=\"column.type == 'multimedia'\">\r\n                          <img src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" class=\"media-object\"\r\n                            width=\"200px;\" />\r\n                        </ng-template>\r\n\r\n                        <ng-template [ngIf]=\"column.type == 'video'\">\r\n                          <video width=\"200\" height=\"200\" controls>\r\n                            <source src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" type=\"video/mp4\">\r\n                            Your browser does not support the video tag.\r\n                          </video>\r\n                        </ng-template>\r\n                      </td>\r\n                    </ng-template>\r\n                  </ng-template>\r\n                  <td [rowSpan]=\"item._rowCount\" *ngIf=\"item._render._tdVisible[i] && commentsEnabled\"\r\n                    class=\"dt-action-column\" (click)=\"showCommentsButtonClicked(item)\" matTooltip=\"Yorumlar\"\r\n                    matTooltipPosition=\"above\">\r\n                    <i class=\"fa fa-comments\"></i>\r\n                    <span class=\"badge badge-danger\" *ngIf=\"item.commentCount > 0\">{{item.commentCount}}</span>\r\n                  </td>\r\n                  <td [rowSpan]=\"item._rowCount\" *ngIf=\"item._render._tdVisible[i] && documentsEnabled\"\r\n                    class=\"dt-action-column\" (click)=\"showDocumentsButtonClicked(item)\" matTooltip=\"Dok\u00FCmanlar\"\r\n                    matTooltipPosition=\"above\">\r\n                    <i class=\"fa fa-file-text-o\"></i>\r\n                    <span class=\"badge badge-danger\" *ngIf=\"item.documentCount > 0\">{{item.documentCount}}</span>\r\n                  </td>\r\n                  <td [rowSpan]=\"item._rowCount\" class=\"sticky-column-with-fake-border\"\r\n                    *ngIf=\"item._render._tdVisible[i]\" style=\"text-align: center\">\r\n                    <a class=\"dropdown-toggle row-actions-btn\" (click)=\"toggleActionsDropdown($event, item)\"\r\n                      data-toggle=\"dropdown\" aria-expanded=\"true\"><i class=\"pe-7s-more\" aria-hidden=\"true\"\r\n                        style=\"color:#d3dbe9 !important;font-size: 18px;\"></i></a>\r\n                  </td>\r\n                </tr>\r\n              </ng-template>\r\n            </ng-template>\r\n            <ng-template [ngIf]=\"containsNestedData == false\">\r\n              <tr *ngFor=\"let item of items; let rowIndex = index\" [ngStyle]=\"item?._render?._deletedCondition\"\r\n                class=\"data-row bordered-row\" (dblclick)=\"itemClicked(item)\" (contextmenu)=\"onRightClick($event, item)\"\r\n                [ngClass]=\"item._disabled ? 'invalid-row' : ''\">\r\n                <td *ngIf=\"uiSelectionEnabled\">\r\n                  <app-checkbox [(checked)]=\"item._selected\" (checkedChange)=\"checkedChanged(item)\"></app-checkbox>\r\n                </td>\r\n                <td *ngFor=\"let column of activeColumns; let columnIndex = index\" [title]=\"item._render[column.field]\"\r\n                  (click)=\"columnSelected(rowIndex, columnIndex, item)\"\r\n                  [ngStyle]=\"{'min-width':  column.minWidth ? column.minWidth: '75px','background-color':  ((rowIndex == activeRow) && (columnIndex == activeColumn)) ? '#d3dbe9': 'transparent', 'border': ((rowIndex == rowToBeSelected) && (columnIndex == columnToBeSelected)) ? '1px dashed black': '1px solid #e7ecf1'}\">\r\n                  <ng-template [ngIf]=\"column.type == 'condition'\">\r\n                    <div [innerHTML]=\"item._render['_template_' + column.index]\"></div>\r\n                  </ng-template>\r\n                  <ng-template [ngIf]=\"column.type == 'html'\">\r\n                    <div [innerHTML]=\"item._render[column.field]\"></div>\r\n                  </ng-template>\r\n                  <ng-template [ngIf]=\"column.type == 'data' || column.type == 'date'\">\r\n                    {{item._render[column.field]}}\r\n                  </ng-template>\r\n\r\n                  <ng-template [ngIf]=\"column.type == 'multimedia'\">\r\n                    <img src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" class=\"media-object\"\r\n                      width=\"200px;\" />\r\n                  </ng-template>\r\n\r\n                  <ng-template [ngIf]=\"column.type == 'video'\">\r\n                    <video width=\"200\" height=\"200\" controls>\r\n                      <source src=\"{{baseURL}}multimedia/{{item._render[column.field]}}\" type=\"video/mp4\">\r\n                      Your browser does not support the video tag.\r\n                    </video>\r\n                  </ng-template>\r\n                </td>\r\n                <td *ngIf=\"commentsEnabled\" class=\"dt-action-column\" (click)=\"showCommentsButtonClicked(item)\"\r\n                  matTooltip=\"Yorumlar\" matTooltipPosition=\"above\">\r\n                  <i class=\"fa fa-comments\"></i>\r\n                  <span class=\"badge badge-danger\" *ngIf=\"item.commentCount > 0\">{{item.commentCount}}</span>\r\n                </td>\r\n                <td *ngIf=\"documentsEnabled\" class=\"dt-action-column\" (click)=\"showDocumentsButtonClicked(item)\"\r\n                  matTooltip=\"Dok\u00FCmanlar\" matTooltipPosition=\"above\">\r\n                  <i class=\"fa fa-file-text-o\"></i>\r\n                  <span class=\"badge badge-danger\" *ngIf=\"item.documentCount > 0\">{{item.documentCount}}</span>\r\n                </td>\r\n                <td class=\"sticky-column-with-fake-border\" style=\"text-align: center\">\r\n                  <a class=\"dropdown-toggle row-actions-btn\" (click)=\"toggleActionsDropdown($event, item)\"\r\n                    data-toggle=\"dropdown\" aria-expanded=\"true\"><i class=\"pe-7s-more\" aria-hidden=\"true\" style=\"color:#d3dbe9 !important;font-size: 18px;vertical-align: middle;\r\n                      \"></i></a>\r\n                </td>\r\n              </tr>\r\n            </ng-template>\r\n            <tr *ngIf=\"placeboRowHeight > 0\" [style.height.px]=\"placeboRowHeight\">\r\n              <td [colSpan]=\"columnCount + 1\">\r\n                <div [class.hidden]=\"loading || !enabled || items.length > 0\">\r\n                  <ng-template [ngIf]=\"emptyResultPagerTemplate === undefined\">\r\n                    <p\r\n                      style=\"text-align:center; width: 1100px !important /* Switch to css with media queries to support responsive */;\">\r\n                      {{'LISTS.preEntityNotFound' | translate}}\r\n                      <!-- <a (click)=\"presentInsertForm()\"> {{'LISTS.entityNotFoundNavigation' | translate}} </a> {{'LISTS.postEntityNotFound' | translate}} -->\r\n                    </p>\r\n                  </ng-template>\r\n                  <ng-template [ngIf]=\"emptyResultPagerTemplate !== undefined\">\r\n                    <div [innerHTML]=\"emptyResultPagerTemplate\"></div>\r\n                  </ng-template>\r\n                </div>\r\n              </td>\r\n            </tr>\r\n          </tbody>\r\n        </table>\r\n      </div>\r\n      <!-- </ng-scrollbar> -->\r\n    </div>\r\n  </div>\r\n  <div class=\"row\">\r\n    <div class=\"col-md-4 col-sm-4\">\r\n      <div *ngIf=\"pageCount >= itemCount && itemCount > 0\" class=\"dataTables_info\" translate=\"MESSAGES.allRecords\"\r\n        [translateParams]=\"{itemCount:itemCount}\"></div>\r\n      <div *ngIf=\"pageCount < itemCount\" class=\"dataTables_info\" translate=\"MESSAGES.partialRecords\"\r\n        [translateParams]=\"{itemCount:itemCount, startIndex:(pageIndex*pageCount + 1), endIndex:((pageIndex*pageCount + pageCount) > itemCount ? itemCount : pageIndex*pageCount + pageCount)}\">\r\n      </div>\r\n    </div>\r\n    <div class=\"col-md-6 col-sm-6\">\r\n      <ng-template [ngIf]=\"itemCount > 0\">\r\n        <div class=\"dataTables_paginate paging_bootstrap_number\" id=\"sample_3_paginate\">\r\n          <pager #pager (onPageIndexChange)=\"pageChanged($event)\" [(itemCount)]=\"itemCount\"\r\n            [(activePageIndex)]=\"pageIndex\" [(itemCountPerPage)]=\"pageCount\"> </pager>\r\n        </div>\r\n      </ng-template>\r\n    </div>\r\n    <div class=\"col-md-2 col-sm-2\">\r\n      <select *ngIf=\"items != undefined && itemCount * 2 > 50\" class=\"form-control\" id=\"pageCount\" name=\"pageCount\"\r\n        [(ngModel)]=\"pageCount\" (ngModelChange)=\"pageCountChanged($event)\">\r\n        <option *ngIf=\"itemCount * 2 > 50\" value=50>50</option>\r\n        <option *ngIf=\"itemCount * 2 > 250\" value=250>250</option>\r\n        <option *ngIf=\"itemCount * 2 > 500\" value=500>500</option>\r\n        <option *ngIf=\"itemCount * 2 > 501\" value=0>T\u00FCm\u00FC</option>\r\n      </select>\r\n    </div>\r\n  </div>\r\n\r\n\r\n  <div [class.hidden]=\"loading || !enabled || items.length > 0\" *ngIf=\"emptyResultTemplateShownInPager == true\">\r\n    <!-- <ng-template [ngIf]=\"emptyResultPagerTemplate === undefined\" [ngIfElse]=\"emptyResultTemplate\">\r\n    {{'LISTS.preEntityNotFound' | translate}} <a (click)=\"presentInsertForm()\"> {{'LISTS.entityNotFoundNavigation' | translate}} </a> {{'LISTS.postEntityNotFound' | translate}}\r\n  </ng-template> -->\r\n    <ng-template #emptyResultTemplate>\r\n      <div [innerHTML]=\"emptyResultPagerTemplate\"></div>\r\n    </ng-template>\r\n  </div>\r\n  <app-loader *ngIf=\"loading\"></app-loader>\r\n\r\n  <div [class.hidden]=\"activeContextItem === undefined\" [attr.id]=\"'action_menu_container_' + identifier\">\r\n    <ul class=\"dropdown-menu pull-right\" role=\"menu\" style=\"right: 49px; top: 19px;\"\r\n      [attr.id]=\"'action_menu_content_' + identifier\">\r\n      <ng-template ngFor let-action [ngForOf]=\"columnActions\">\r\n        <ng-template [ngIf]=\"activeContextItem !== undefined\">\r\n          <li *ngIf=\"action.meetsConditions(activeContextItem)\">\r\n            <a (click)=\"actionTriggered(action,activeContextItem)\"><i class=\"{{action.icon}}\"></i>\r\n              <ng-template [ngIf]=\"!action.needsTranslation\" [ngIfElse]=\"translationTemplate\">\r\n                {{action.displayText}}\r\n              </ng-template>\r\n              <ng-template #translationTemplate>\r\n                {{action.displayText | translate}}\r\n              </ng-template>\r\n            </a>\r\n          </li>\r\n        </ng-template>\r\n      </ng-template>\r\n    </ul>\r\n  </div>\r\n</div>",
                encapsulation: core.ViewEncapsulation.None,
                host: { '(window:keydown)': 'keyboardInput($event)' },
                providers: [ /*UserDefinedFilterRepository*/]
                //changeDetection: ChangeDetectionStrategy.OnPush
                ,
                styles: [".actions-overlay{content:\" \";position:fixed;background-color:rgba(255,255,255,.1);width:100%;height:100%;z-index:3;left:0;top:0}.dataTables_wrapper{background:0 0}.table-scrollable{border-radius:5px;background-color:#fff;box-shadow:0 2px 3px 0 rgba(0,0,0,.24);border:none!important;overflow-y:visible!important}.application-data-table thead{width:1144.6px;height:50px;background-color:#d3dbe9}.application-data-table thead tr td h4{font-family:\"Open Sans\",sans-serif;letter-spacing:.5px;text-align:left;font-weight:500;color:#4a4a4a;padding-left:4px;padding-right:4px}.application-data-table thead tr th h4{font-family:\"Open Sans\",sans-serif;letter-spacing:.5px;text-align:left;font-weight:500;color:#4a4a4a;padding-left:4px;padding-right:4px;font-size:14px}.application-data-table thead tr th>div{display:flex;justify-content:space-between}.application-data-table tbody tr td .btn-group{position:absolute}.actions-column .dropdown-menu{margin-top:10px!important}.actions-column .dropdown-menu li{background-color:#fafcff}.actions-column .dropdown-menu li a{transition:.3s cubic-bezier(.175,.885,.32,1.275)}.actions-column .dropdown-menu li:not(:first-child){margin:3px 0}.actions-column .dropdown-menu li a:hover{background-color:rgba(55,130,195,.2)}.actions-column .btn-group.open .dropdown-menu li:first-child:before{content:\" \";right:5px;z-index:999;position:absolute;width:0;height:0;top:-9px;border:5px solid transparent;border-top:5px solid rgba(55,130,195,.2)}.row-actions-btn{border-radius:50%;width:35px;height:25px;display:inline-block;padding-top:2px;margin:0 auto}.row-actions-btn img{max-height:20px;margin:0 2px 2px}@media (min-width:736px) and (max-width:1024px){.btn-group.open .dropdown-menu li:first-child:before{content:\" \";right:5px;z-index:999;position:absolute;width:0;height:0;top:-9px;border:5px solid transparent;border-top:5px solid #3782c3}}@media (max-width:544px){.table-scrollable{position:relative}.table-scrollable .row-actions-column .btn-group{right:48px}.table-responsive .dropdown-menu{position:fixed;bottom:0;width:100%;max-height:100%;top:auto;overflow:scroll;padding:0;z-index:1000;margin:0;min-height:92px;transition:.5s cubic-bezier(.175,.885,.32,1.275)}.table-responsive .input-group-btn.open:before{display:block;width:100%;height:100%;content:\" \";top:0;left:0;background-color:rgba(217,230,240,.5);z-index:9;position:fixed}.table-scrollable .dropdown-menu li{position:relative!important;display:block!important;z-index:1200;padding:3px;margin:5px;border-radius:8px}.dropdown-backdrop{background-color:rgba(206,221,239,.2);z-index:1}.application-data-table tbody .row-actions-column .btn-group{right:48px}.row-actions-column{position:relative}}.row-actions-column .btn.btn-circle{width:25px;height:25px;padding:2.5px 0;font-size:12px}.table-container{margin-bottom:20px}.table-container table{margin-bottom:5px;min-height:150px;background-color:#fff}.table-container table tr.mock-row{height:150px}.table-container table thead th{white-space:nowrap;background-color:#d3dbe9!important;color:#4a4a4a}.table-container table thead th h4{font-family:\"Open Sans\",sans-serif;letter-spacing:.5px;text-align:left;font-weight:500;color:#4a4a4a;padding-left:4px;padding-right:4px;font-size:14px}.table-container .table-responsive{border:none;box-shadow:0 2px 3px 0 rgba(0,0,0,.24)}.table-container:before{display:table;content:\" \"}.table-container:after{display:table;content:\" \";clear:both}.table-container>div{padding:0!important;float:left;position:relative;z-index:1}.table-container .table-column th>div{display:flex;justify-content:space-between}.table-container:not(.has-actions){border-radius:5px}.table-container:not(.has-actions) .table-column{width:100%}.table-container:not(.has-actions) .table-column .table-responsive{border-radius:5px}.table-container.has-actions .table-column{width:calc(100%)}.table-container.has-actions .table-column .table-responsive{border-top-left-radius:5px;border-bottom-right-radius:5px}.table-container.has-actions .table-column .table-responsive table tbody .filter-row{height:42px}.table-container.has-actions .table-column .table-responsive table tbody .filter-row td{background-color:#fff;position:-webkit-sticky;position:sticky;top:38px;z-index:1000;padding:4px!important;vertical-align:middle!important}.table-container.has-actions .table-column .table-responsive table tbody .filter-row boolean-filter .form-group{margin:-1px 4px 4px!important}.table-container.has-actions .table-column .table-responsive table tbody .filter-row .dropdown button,.table-container.has-actions .table-column .table-responsive table tbody .filter-row input-filter .input-group{margin-top:-5px}.table-container.has-actions .actions-column{width:54px;border-left:3px solid #d3dbe9;text-align:center;z-index:4;max-height:480px;overflow-y:auto;padding-bottom:18px!important}.table-container.has-actions .actions-column th{border-top-right-radius:5px}.table-container.has-actions .actions-column th>div{min-height:35px;text-align:center;padding-top:5px}.table-container.has-actions .actions-column th h4{text-align:center}.table-container.has-actions .actions-column td{padding:5px;white-space:nowrap;vertical-align:middle}.table-container.has-actions .actions-column td .btn-group.open>ul{position:fixed;z-index:1;top:464px;right:425px;height:auto}@media (max-width:644px){.table-container.has-actions .actions-column .row-actions-column .btn-group button i{margin:0 0 0 -1px!important}.table-container.has-actions .actions-column .row-actions-column .btn-group .dropdown-menu li:first-child:before{right:.5em;top:-11px}.table-container.has-actions .actions-column .row-actions-column .dropdown-menu{position:fixed;bottom:0;width:100%;max-height:100%;top:auto;overflow:scroll;padding:0;z-index:1000;margin:0;min-height:92px;transition:.5s cubic-bezier(.175,.885,.32,1.275)}.table-container.has-actions .actions-column .row-actions-column .dropdown-menu li{position:relative!important;display:block!important;z-index:1200;padding:3px;margin:5px;border-radius:8px}.table-container.has-actions .actions-column .btn-group.open:before,.table-container.has-actions .actions-column .dropdown.open{display:block;width:100%;height:100%;content:\" \";top:0;left:0;background-color:rgba(217,230,240,.5);z-index:9;position:fixed}}.dropdown-backdrop{z-index:1}::-webkit-scrollbar{width:10px;background-color:#fff}::-webkit-scrollbar-track{border-radius:3px;background-color:#fff}::-webkit-scrollbar-thumb{border-radius:3px;background-color:#d3dbe9}.application-data-table thead tr th{position:-webkit-sticky;position:sticky;top:0;z-index:1000}.sticky-column-with-fake-border{background:url(data:image/gif;base64,R0lGODlhAQABAIAAAMLCwgAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw==) left repeat-y #fff;width:50px!important;position:-webkit-sticky;position:sticky;right:0;z-index:50}.magnifier{font-size:1.5em}.clear-filters{font-size:1.2em}.application-data-table>tbody>tr>td,.application-data-table>tbody>tr>th,.application-data-table>tfoot>tr>td,.application-data-table>tfoot>tr>th,.application-data-table>thead>tr>td,.application-data-table>thead>tr>th{vertical-align:middle!important;padding:2px}.dt-action-column{padding:10px!important;font-size:20px!important;color:#adadad!important;cursor:pointer}.dt-action-column .badge{margin-top:-25px;margin-left:-13px}.table-nowrap table tbody tr{white-space:nowrap}.table-nowrap table tbody tr td{margin:0!important;padding:0 0 0 5px!important}.table-nowrap table tbody tr td app-checkbox div{margin:0 -2px 0 2px!important;padding:0!important}.table-nowrap table tbody tr td app-checkbox div .application-checkbox-selected{margin:2px -2px 0 2px!important}.table-scroll-enabled{max-height:480px;overflow-y:scroll}.table-scroll-disabled{max-height:unset;overflow-y:visible}.table-nowrap .data-row .input-group-addon,.table-nowrap .data-row input,.table-nowrap .data-row select{border:none!important;background-color:transparent!important}.table-nowrap .data-row .input-group-addon{background-color:transparent!important;border-radius:0;border-left:1px solid #e3e3e3!important;padding-left:5px!important;padding-right:0!important}.invalid-row{background-color:#f7c9c5!important}.bordered-row:hover{box-shadow:inset 1px 0 0 #dadce0,inset -1px 0 0 #dadce0,0 1px 2px 0 rgba(60,64,67,.3),0 1px 3px 1px rgba(60,64,67,.15)}.sticky-column-with-fake-border a:hover{text-decoration:none!important;background-color:#f3f6f8;transition:background-color .7s cubic-bezier(.71,.29,.21,.49)}.lds-roller{display:inline-block;position:relative;width:64px;height:64px;left:50%;transform:translate(-50%)}.lds-roller div{-webkit-animation:1.2s cubic-bezier(.5,0,.5,1) infinite lds-roller;animation:1.2s cubic-bezier(.5,0,.5,1) infinite lds-roller;transform-origin:32px 32px}.lds-roller div:after{content:\" \";display:block;position:absolute;width:6px;height:6px;border-radius:50%;background:#000;margin:-3px 0 0 -3px}.lds-roller div:nth-child(1){-webkit-animation-delay:-36ms;animation-delay:-36ms}.lds-roller div:nth-child(1):after{top:50px;left:50px}.lds-roller div:nth-child(2){-webkit-animation-delay:-72ms;animation-delay:-72ms}.lds-roller div:nth-child(2):after{top:54px;left:45px}.lds-roller div:nth-child(3){-webkit-animation-delay:-108ms;animation-delay:-108ms}.lds-roller div:nth-child(3):after{top:57px;left:39px}.lds-roller div:nth-child(4){-webkit-animation-delay:-144ms;animation-delay:-144ms}.lds-roller div:nth-child(4):after{top:58px;left:32px}.lds-roller div:nth-child(5){-webkit-animation-delay:-.18s;animation-delay:-.18s}.lds-roller div:nth-child(5):after{top:57px;left:25px}.lds-roller div:nth-child(6){-webkit-animation-delay:-216ms;animation-delay:-216ms}.lds-roller div:nth-child(6):after{top:54px;left:19px}.lds-roller div:nth-child(7){-webkit-animation-delay:-252ms;animation-delay:-252ms}.lds-roller div:nth-child(7):after{top:50px;left:14px}.lds-roller div:nth-child(8){-webkit-animation-delay:-288ms;animation-delay:-288ms}.lds-roller div:nth-child(8):after{top:45px;left:10px}@-webkit-keyframes lds-roller{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes lds-roller{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}"]
            })
        ], DataTableComponent);
        return DataTableComponent;
    }());
    var TableSettingMode;
    (function (TableSettingMode) {
        TableSettingMode[TableSettingMode["Default"] = 1] = "Default";
        TableSettingMode[TableSettingMode["FilterManagement"] = 2] = "FilterManagement";
    })(TableSettingMode || (TableSettingMode = {}));
    var FilterManagementPageMode;
    (function (FilterManagementPageMode) {
        FilterManagementPageMode[FilterManagementPageMode["List"] = 0] = "List";
        FilterManagementPageMode[FilterManagementPageMode["Insert"] = 1] = "Insert";
        FilterManagementPageMode[FilterManagementPageMode["Update"] = 2] = "Update";
    })(FilterManagementPageMode || (FilterManagementPageMode = {}));
    var UserDefinedFilterModel = /** @class */ (function () {
        function UserDefinedFilterModel() {
        }
        return UserDefinedFilterModel;
    }());

    var Action = /** @class */ (function () {
        function Action() {
            this.conditionDirection = true;
            this.needsTranslation = false;
        }
        Action.prototype.meetsConditions = function (item) {
            var e_1, _a;
            if (this.conditionField == undefined && this.conditions == undefined)
                return true;
            if (this.conditionField != undefined) {
                if ((this.conditionDirection == true && this.condition == item[this.conditionField]) || (this.conditionDirection == false && this.condition != item[this.conditionField])) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else if (this.conditions != undefined) {
                try {
                    for (var _b = __values(this.conditions), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var condition = _c.value;
                        if (condition.field != undefined) {
                            if (!((condition.direction == true && condition.condition == item[condition.field]) || (condition.direction == false && condition.condition != item[condition.field]))) {
                                return false;
                            }
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return true;
        };
        Action.prototype.addCondition = function (field, condition, direction) {
            if (direction === void 0) { direction = true; }
            if (this.conditions == undefined)
                this.conditions = new Array();
            var item = new Condition();
            item.condition = condition;
            item.field = field;
            item.direction = direction;
            this.conditions.push(item);
        };
        Action.parse = function (element) {
            if (element == undefined)
                return undefined;
            var action = new Action();
            action.displayText = element.displayText;
            action.actionMethodName = element.actionMethodName;
            action.action = element.action;
            action.icon = element.icon;
            action.hasCondition = element.hasCondition;
            action.condition = element.condition;
            action.conditionField = element.conditionField;
            if (action.displayText.startsWith("FORMS.")) {
                action.needsTranslation = true;
            }
            return action;
        };
        return Action;
    }());

    var TableConfiguration = /** @class */ (function () {
        function TableConfiguration() {
            this.enabled = true;
            this.actionHeader = "";
        }
        TableConfiguration.parseList = function (objects) {
            if (objects == undefined)
                return undefined;
            var items = new Array();
            objects.forEach(function (element) {
                items.push(TableConfiguration.parse(element));
            });
            return items;
        };
        TableConfiguration.parse = function (element) {
            if (element == undefined)
                return undefined;
            var configuration = new TableConfiguration();
            configuration.columns = Column.parseList(element["columns"]);
            var actionColumn = element["actionColumn"];
            if (actionColumn !== undefined) {
                configuration.actionColumn = new Column();
                configuration.actionColumn.displayText = actionColumn["displayText"];
                configuration.actionHeader = actionColumn["actionButtonDisplayText"];
            }
            configuration.enabled = element["enabled"];
            return configuration;
        };
        return TableConfiguration;
    }());

    var GenericFilterRepository = /** @class */ (function () {
        function GenericFilterRepository(http) {
            this.http = http;
        }
        GenericFilterRepository.prototype.getAll = function (target, pageIndex, pageCount, includeInactive, filter, sort, extendStrings, includeDeleted, includeSystemColumns) {
            if (filter === void 0) { filter = undefined; }
            if (sort === void 0) { sort = undefined; }
            if (extendStrings === void 0) { extendStrings = undefined; }
            if (includeDeleted === void 0) { includeDeleted = false; }
            if (includeSystemColumns === void 0) { includeSystemColumns = undefined; }
            var baseRepository = new clAngularCore.BaseRepository(undefined);
            var data = { pageIndex: pageIndex, pageCount: pageCount, includeInactive: includeInactive, includeSystemColumns: includeSystemColumns };
            baseRepository.applyCriteria(data, filter, sort, extendStrings);
            var deletedPostFix = includeDeleted === true ? '/deleted' : '';
            return this.http
                .post(baseRepository.apiRoot + target + "/list" + deletedPostFix, JSON.stringify(data), { headers: baseRepository.defaultHeaders() }).toPromise()
                .then(function (responseObject) {
                return new clAngularCore.ResponseModel(undefined, responseObject);
            });
        };
        GenericFilterRepository.getPath = function (input) {
            var path = input.replace(/([a-z])([A-Z])/g, '$1-$2');
            path = this.pluralize(path);
            return path;
        };
        GenericFilterRepository.pluralize = function (element) {
            var path = element;
            if (path.endsWith('y')) {
                path = path.substring(0, path.length - 1) + 'ies';
            }
            else {
                path = path + 's';
            }
            return path;
        };
        GenericFilterRepository.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        GenericFilterRepository = __decorate([
            core.Injectable()
        ], GenericFilterRepository);
        return GenericFilterRepository;
    }());

    var DataTableFilterComponent = /** @class */ (function () {
        function DataTableFilterComponent(genericRepository) {
            this.genericRepository = genericRepository;
            this.settings = new clAngularCombobox.ComboboxSettings();
            this.comboboxStyle = new clAngularCombobox.ComboboxStyles();
            this.optionsModel = [];
            this.triggerFilterChanged = true;
            this.onFilterChanged = new core.EventEmitter();
            this.comboboxItemsLoaded = new core.EventEmitter();
        }
        DataTableFilterComponent.prototype.onSelectFilterChanged = function ($event) {
            if ($event.length == 0) {
                this.filter.value = undefined;
            }
            else {
                var selectedItems = $event;
                this.filter.value = selectedItems.map(function (x) { return x.value; });
            }
            if (this.triggerFilterChanged)
                this.onFilterChanged.emit({ filter: this.filter });
        };
        DataTableFilterComponent.prototype.updateFilters = function () {
            this.triggerFilterChanged = false;
            if (this.inputFilter)
                this.inputFilter.updateFilters();
            if (this.dateFilter)
                this.dateFilter.updateFilters();
            if (this.booleanFilter)
                this.booleanFilter.updateFilters();
            if (this._combobox) {
                if (this.filter && this.filter.items) {
                    this._combobox.selectedItems = this.filter.items.filter(function (x) { return x.selected == true; });
                }
            }
            this.triggerFilterChanged = true;
        };
        Object.defineProperty(DataTableFilterComponent.prototype, "filter", {
            get: function () {
                return this._filter;
            },
            set: function (v) {
                this._filter = v;
            },
            enumerable: true,
            configurable: true
        });
        DataTableFilterComponent.prototype.initializeComboboxSettings = function () {
            //this.comboboxStyle.buttonClasses = "btn btn-default btn-block";
            this.comboboxStyle.buttonStyles = {};
            this.settings.enableSearch = true;
            this.settings.searchMaxLimit = 25;
        };
        DataTableFilterComponent.prototype.ngOnInit = function () {
            if (this.filter.allowMultipleSelections == false) {
            }
            else {
            }
            this.initializeComboboxSettings();
        };
        DataTableFilterComponent.prototype.onSelectionChanged = function ($event) {
            if ($event != this.filter.value) {
                this.filter.value = $event;
                this.searchInputChanged();
            }
        };
        DataTableFilterComponent.prototype.onFilterOperationChanged = function ($event) {
            if ($event != this.filter.operation) {
                this.filter.operation = $event;
                this.searchInputChanged();
            }
        };
        DataTableFilterComponent.prototype.searchInputChanged = function () {
            this.onFilterChanged.emit({ filter: this.filter });
        };
        DataTableFilterComponent.prototype.filterChanged = function ($event) {
            this.onFilterChanged.emit({ filter: this.filter });
        };
        // Auto filter loader
        DataTableFilterComponent.prototype.setFilter = function (items, operator) {
            if (operator === void 0) { operator = undefined; }
            if (this.filter.type == 4) {
                this.filter.items = items;
                this.filter.loading = false;
                if (operator) {
                    this.filter.operation = operator;
                }
            }
        };
        DataTableFilterComponent.prototype.createComboboxPromise = function (promiseLoader) {
            if (promiseLoader === void 0) { promiseLoader = new clAngularCombobox.PromiseParameters(); }
            if (this.filter.autoFilterRequestEnabled == false)
                return;
            var path = this.filter.sourceTable;
            if (path === undefined || path == '')
                return;
            var filter = undefined;
            if (promiseLoader.filterKey != undefined && promiseLoader.filterKey.length > 0) {
                var criteria = new clAngularCore.SearchCriteria();
                criteria.keys = this.filter.sourceTableSearchKeys;
                criteria.value = promiseLoader.filterKey;
                filter = [criteria];
            }
            this.comboboxPromise = this.genericRepository.getAll(this.getPath(path), promiseLoader.pageIndex, promiseLoader.pageCount, false, filter, undefined, undefined, false, true);
        };
        DataTableFilterComponent.prototype.getPath = function (input) {
            var path = input.replace(/([a-z])([A-Z])/g, '$1-$2');
            path = this.pluralize(path);
            return path;
        };
        DataTableFilterComponent.prototype.splitCamel = function (element) {
            var path = element.replace(/([a-z])([A-Z])/g, '$1 $2');
            return path;
        };
        DataTableFilterComponent.prototype.pluralize = function (element) {
            var path = element;
            if (path.endsWith('y')) {
                path = path.substring(0, path.length - 1) + 'ies';
            }
            else {
                path = path + 's';
            }
            return path;
        };
        Object.defineProperty(DataTableFilterComponent.prototype, "combobox", {
            set: function (combobox) {
                this._combobox = combobox;
                if (this._combobox !== undefined) {
                    combobox.context = this;
                    combobox.onSuccess = this.comboboxPromiseLoaded;
                    this.filter.combobox = combobox;
                }
            },
            enumerable: true,
            configurable: true
        });
        DataTableFilterComponent.prototype.comboboxPromiseLoaded = function ($event) {
            var _a;
            var items = [];
            $event.entities.forEach(function (entity) {
                var item = new FilterItem();
                item.key = entity["dataDisplayText"];
                item.value = entity["id"];
                items.push(item);
            });
            if (this.filter.items === undefined)
                this.filter.items = items;
            else
                (_a = this.filter.items).push.apply(_a, __spread(items));
            this.comboboxItemsLoaded.emit(items);
            return items;
        };
        DataTableFilterComponent.ctorParameters = function () { return [
            { type: GenericFilterRepository }
        ]; };
        __decorate([
            core.ViewChild('inputFilter')
        ], DataTableFilterComponent.prototype, "inputFilter", void 0);
        __decorate([
            core.ViewChild('dateFilter')
        ], DataTableFilterComponent.prototype, "dateFilter", void 0);
        __decorate([
            core.ViewChild('booleanFilter')
        ], DataTableFilterComponent.prototype, "booleanFilter", void 0);
        __decorate([
            core.Input()
        ], DataTableFilterComponent.prototype, "filter", null);
        __decorate([
            core.Output()
        ], DataTableFilterComponent.prototype, "onFilterChanged", void 0);
        __decorate([
            core.ViewChild("combobox")
        ], DataTableFilterComponent.prototype, "combobox", null);
        __decorate([
            core.Output()
        ], DataTableFilterComponent.prototype, "comboboxItemsLoaded", void 0);
        DataTableFilterComponent = __decorate([
            core.Component({
                selector: 'data-table-filter',
                template: "<input-filter #inputFilter *ngIf=\"filter.type == 0 || filter.type == 1\" [(filter)]=\"filter\" (onFilterChanged)=\"filterChanged($event)\">\r\n</input-filter>\r\n\r\n<date-filter #dateFilter *ngIf=\"filter.type == 2\" [filter]=\"filter\" (onFilterChanged)=\"filterChanged($event)\"></date-filter>\r\n\r\n<boolean-filter #booleanFilter *ngIf=\"filter.type == 3\" [filter]=\"filter\" (onFilterChanged)=\"filterChanged($event)\"></boolean-filter>\r\n\r\n<app-combobox *ngIf=\"filter.type == 4\" #combobox [showLabel]=\"false\" [styles]=\"comboboxStyle\" [(settings)]=\"settings\"\r\n    [enablePromise]=\"filter.autoFilterRequestEnabled\" [rawItems]=\"filter.items\" (selectedItemsChange)=\"onSelectFilterChanged($event)\"\r\n    [(request)]=\"comboboxPromise\" (promiseLoader)=\"createComboboxPromise($event)\">\r\n</app-combobox>",
                providers: [GenericFilterRepository]
            })
        ], DataTableFilterComponent);
        return DataTableFilterComponent;
    }());

    var MultiSelectSearchFilter = /** @class */ (function () {
        function MultiSelectSearchFilter() {
            this._searchCache = {};
            this._searchCacheInclusive = {};
        }
        MultiSelectSearchFilter.prototype.transform = function (options, str, limit, renderLimit) {
            if (limit === void 0) { limit = 0; }
            if (renderLimit === void 0) { renderLimit = 0; }
            str = (str || '').toLowerCase();
            // Drop cache because options were updated
            if (options !== this._lastOptions) {
                this._lastOptions = options;
                this._searchCache = {};
                this._searchCacheInclusive = {};
            }
            var isUnderLimit = options.length <= limit;
            if (this._searchCache[str]) {
                return isUnderLimit ? this._searchCache[str] : this._limitRenderedItems(this._searchCache[str], renderLimit);
            }
            var prevStr = str.slice(0, -1);
            var prevResults = this._searchCache[prevStr];
            if (prevResults) {
                var prevInclusiveOrIdx = this._searchCacheInclusive[prevStr];
                if (prevInclusiveOrIdx === true) {
                    // If have previous results and it was inclusive, do only subsearch
                    options = prevResults;
                }
                else if (typeof prevInclusiveOrIdx === 'number') {
                    // Or reuse prev results with unchecked ones
                    options = __spread(prevResults, options.slice(prevInclusiveOrIdx));
                }
            }
            var optsLength = options.length;
            var maxFound = limit > 0 ? Math.min(limit, optsLength) : optsLength;
            var filteredOpts = [];
            var regexp = new RegExp(this._escapeRegExp(str), 'i');
            var matchPredicate = function (option) { return regexp.test(option.key); }, getChildren = function (option) { return options.filter(function (child) { return child.parentId === option.value; }); }, getParent = function (option) { return options.find(function (parent) { return option.parentId === parent.value; }); };
            var i = 0, founded = 0;
            for (; i < optsLength && founded < maxFound; ++i) {
                var option = options[i];
                var directMatch = regexp.test(option.key);
                if (directMatch) {
                    filteredOpts.push(option);
                    founded++;
                    continue;
                }
                if (typeof (option.parentId) === 'undefined') {
                    var childrenMatch = getChildren(option).some(matchPredicate);
                    if (childrenMatch) {
                        filteredOpts.push(option);
                        founded++;
                        continue;
                    }
                }
                if (typeof (option.parentId) !== 'undefined') {
                    var parentMatch = matchPredicate(getParent(option));
                    if (parentMatch) {
                        filteredOpts.push(option);
                        founded++;
                        continue;
                    }
                }
            }
            this._searchCache[str] = filteredOpts;
            this._searchCacheInclusive[str] = i === optsLength || i + 1;
            return isUnderLimit ? filteredOpts : this._limitRenderedItems(filteredOpts, renderLimit);
        };
        MultiSelectSearchFilter.prototype._limitRenderedItems = function (items, limit) {
            return items.length > limit && limit > 0 ? items.slice(0, limit) : items;
        };
        MultiSelectSearchFilter.prototype._escapeRegExp = function (str) {
            return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        };
        MultiSelectSearchFilter = __decorate([
            core.Pipe({
                name: 'searchFilter'
            })
        ], MultiSelectSearchFilter);
        return MultiSelectSearchFilter;
    }());

    var BaseFilter = /** @class */ (function () {
        function BaseFilter() {
            this.triggerFilterChanged = true;
            this.onFilterChanged = new core.EventEmitter();
        }
        BaseFilter.prototype.updateFilters = function () {
            this.triggerFilterChanged = false;
            this.filterValue = this.filter.value;
            this.triggerFilterChanged = true;
        };
        __decorate([
            core.Input()
        ], BaseFilter.prototype, "filter", void 0);
        __decorate([
            core.Output()
        ], BaseFilter.prototype, "onFilterChanged", void 0);
        BaseFilter = __decorate([
            core.Directive()
        ], BaseFilter);
        return BaseFilter;
    }());

    var InputFilterComponent = /** @class */ (function (_super) {
        __extends(InputFilterComponent, _super);
        function InputFilterComponent() {
            return _super.call(this) || this;
        }
        InputFilterComponent.prototype.ngOnInit = function () {
            if (this.filter !== undefined && this.filter.value) {
                this.filter.value = this.filter.value.trim();
                this.filterValue = this.filter.value;
            }
        };
        InputFilterComponent.prototype.onFilterOperationChanged = function ($event) {
            if (this.filter.operation != $event) {
                this.filter.operation = $event;
                if (this.triggerFilterChanged)
                    this.onFilterChanged.emit({ filter: this.filter });
            }
        };
        InputFilterComponent.prototype.searchInputChanged = function () {
            if (this.filterValue != this.filter.value) {
                this.filter.value = this.filterValue;
                if (this.triggerFilterChanged)
                    this.onFilterChanged.emit({ filter: this.filter });
            }
        };
        InputFilterComponent = __decorate([
            core.Component({
                selector: 'input-filter',
                template: "<div class=\"input-group\">\r\n  <input class=\"form-control\" [(ngModel)]=\"filterValue\" (ngModelChange)=\"searchInputChanged()\" placeholder=\"{{filter.placeholder}}\"\r\n    style=\"min-width: 125px;\" />\r\n  <div *ngIf=\"filter.type == 0\" class=\"input-group-btn\">\r\n    <button type=\"button\" class=\"btn btn-default dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\"\r\n      aria-expanded=\"false\" style=\"box-shadow: none !important; padding-left: 8px; padding-right: 8px;\">\r\n      <i class=\"fa\" [class.fa-align-center]=\"filter.operation == undefined\" [class.fa-align-left]=\"filter.operation == 'StartsWith'\"\r\n        [class.fa-align-right]=\"filter.operation == 'EndsWith'\" [class.fa-align-justify]=\"filter.operation == 'Matches'\"></i>\r\n    </button>\r\n    <ul class=\"dropdown-menu pull-right\">\r\n      <li><a (click)=\"onFilterOperationChanged(undefined)\"><i class=\"fa fa-align-center\"></i> \u0130\u00E7inde\r\n          ge\u00E7en</a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('StartsWith')\"><i class=\"fa fa-align-left\"></i>\u0130le\r\n          ba\u015Flayan</a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('EndsWith')\"><i class=\"fa fa-align-right\"></i>\u0130le biten</a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('Matches')\"><i class=\"fa fa-align-justify\"></i>E\u015Fle\u015Fen</a></li>\r\n    </ul>\r\n  </div><!-- /btn-group -->\r\n\r\n  <div *ngIf=\"filter.type == 1\" class=\"input-group-btn\">\r\n    <button type=\"button\" class=\"btn btn-default dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\"\r\n      aria-expanded=\"false\" style=\"box-shadow: none !important; padding-left: 8px; padding-right: 8px;\">\r\n      <ng-template [ngIf]=\"filter.operation != undefined\">{{filter.operation}}</ng-template>\r\n      <ng-template [ngIf]=\"filter.operation == undefined\">=</ng-template>\r\n    </button>\r\n    <ul class=\"dropdown-menu dropdown-menu-right\" style=\"min-width: 50px; text-align: center;\">\r\n      <li><a (click)=\"onFilterOperationChanged(undefined)\">=</a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('>')\">></a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('>=')\">>=</a></li>\r\n      <li><a (click)=\"onFilterOperationChanged('<')\">\r\n          <</a> </li> <li><a (click)=\"onFilterOperationChanged('<=')\">\r\n              <=</a> </li> </ul> </div> <!-- /btn-group -->\r\n\r\n  </div><!-- /input-group -->"
            })
        ], InputFilterComponent);
        return InputFilterComponent;
    }(BaseFilter));

    var BooleanFilterComponent = /** @class */ (function (_super) {
        __extends(BooleanFilterComponent, _super);
        function BooleanFilterComponent() {
            var _this = _super.call(this) || this;
            _this.checked = undefined;
            return _this;
        }
        BooleanFilterComponent.prototype.toggle = function () {
            if (this.filter.value === undefined)
                this.filter.value = true;
            else if (this.filter.value === true)
                this.filter.value = false;
            else if (this.filter.value === false)
                this.filter.value = undefined;
            this.filter.value = this.filter.value;
            if (this.triggerFilterChanged)
                this.onFilterChanged.emit({ filter: this.filter });
        };
        BooleanFilterComponent.prototype.ngOnInit = function () {
        };
        BooleanFilterComponent = __decorate([
            core.Component({
                selector: 'boolean-filter',
                template: "<div class=\"form-group data-table-noselect\" style=\"cursor:pointer; \" (click)=\"toggle()\">\r\n  <div class=\"data-table-checkbox pull-left\">\r\n    <div *ngIf=\"filter.value == true\" class=\"data-table-checkbox-selected\" style=\"position:relative\">\r\n      <i class=\"fa fa-check\" style=\"color: #5583ae;position: absolute;top: 7px;left: 5px;font-size: 20px;\"></i>\r\n    </div>\r\n    <div *ngIf=\"filter.value == false\" class=\"data-table-checkbox-selected\" style=\"position:relative\">\r\n      <i class=\"fa fa-remove\" style=\"color: #5583ae;position: absolute;top: 7px;left: 7px;font-size: 20px;\"></i>\r\n    </div>\r\n  </div>\r\n  <div class=\"clearfix\"></div>\r\n</div>",
                styles: [".data-table-greyed-out{opacity:.5;cursor:no-drop}.data-table-checkbox{width:30px;height:30px;border-radius:4px;background-color:#fff;border:1px solid #c2cad8;margin:5px 10px 5px 5px}.data-table-checkbox-selected{width:30px;height:30px;border-radius:4px}.data-table-noselect{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}"]
            })
        ], BooleanFilterComponent);
        return BooleanFilterComponent;
    }(BaseFilter));

    var MULTISELECT_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: core.forwardRef(function () { return SelectFilterComponent; }),
        multi: true
    };
    var SelectFilterComponent = /** @class */ (function (_super) {
        __extends(SelectFilterComponent, _super);
        function SelectFilterComponent(element, fb, searchFilter, differs) {
            var _this = _super.call(this) || this;
            _this.element = element;
            _this.fb = fb;
            _this.searchFilter = searchFilter;
            _this.filterControl = _this.fb.control('');
            _this.disabled = false;
            _this.disabledSelection = false;
            _this.selectionLimitReached = new core.EventEmitter();
            _this.dropdownClosed = new core.EventEmitter();
            _this.dropdownOpened = new core.EventEmitter();
            _this.onAdded = new core.EventEmitter();
            _this.onRemoved = new core.EventEmitter();
            _this.onLazyLoad = new core.EventEmitter();
            _this.onFilter = _this.filterControl.valueChanges;
            _this.destroyed$ = new rxjs.Subject();
            _this.filteredOptions = [];
            _this.renderFilteredOptions = [];
            _this.model = [];
            _this.numSelected = 0;
            _this.renderItems = true;
            _this.checkAllSearchRegister = new Set();
            _this.checkAllStatus = false;
            _this.loadedValueIds = [];
            _this.defaultSettings = {
                closeOnClickOutside: true,
                enableSearch: false,
                searchRenderLimit: 0,
                searchRenderAfter: 1,
                searchMaxLimit: 0,
                searchMaxRenderedItems: 0,
                selectionLimit: 0,
                minSelectionLimit: 0,
                closeOnSelect: false,
                autoUnselect: true,
                showCheckAll: false,
                showUncheckAll: false,
                fixedTitle: false,
                dynamicTitleMaxItems: 3,
                maxHeight: '300px',
                isLazyLoad: false,
                stopScrollPropagation: false,
                loadViewDistance: 1,
                selectAddedValues: false
            };
            _this.defaultTexts = {
                checkAll: 'Check all',
                uncheckAll: 'Uncheck all',
                checked: 'checked',
                checkedPlural: 'checked',
                searchPlaceholder: 'Search...',
                searchEmptyResult: 'Nothing found...',
                searchNoRenderText: 'Type in search box to see results...',
                defaultTitle: 'Select',
                allSelected: 'All selected',
            };
            _this._isVisible = false;
            _this._workerDocClicked = false;
            _this.onModelChange = function (_) { };
            _this.onModelTouched = function () { };
            _this.differ = differs.find([]).create(null);
            _this.settings = _this.defaultSettings;
            _this.texts = _this.defaultTexts;
            return _this;
        }
        SelectFilterComponent.prototype.onClick = function (target) {
            if (!this.isVisible || !this.settings.closeOnClickOutside)
                return;
            var parentFound = false;
            while (target != null && !parentFound) {
                if (target === this.element.nativeElement) {
                    parentFound = true;
                }
                target = target.parentElement;
            }
            if (!parentFound) {
                this.isVisible = false;
                this.dropdownClosed.emit();
            }
        };
        Object.defineProperty(SelectFilterComponent.prototype, "isVisible", {
            get: function () {
                return this._isVisible;
            },
            set: function (val) {
                this._isVisible = val;
                this._workerDocClicked = val ? false : this._workerDocClicked;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SelectFilterComponent.prototype, "searchLimit", {
            get: function () {
                return this.settings.searchRenderLimit;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SelectFilterComponent.prototype, "searchRenderAfter", {
            get: function () {
                return this.settings.searchRenderAfter;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SelectFilterComponent.prototype, "searchLimitApplied", {
            get: function () {
                return this.searchLimit > 0 && this.options.length > this.searchLimit;
            },
            enumerable: true,
            configurable: true
        });
        SelectFilterComponent.prototype.getItemStyle = function (option) {
            if (!option.isLabel) {
                return { 'cursor': 'pointer' };
            }
        };
        SelectFilterComponent.prototype.getItemStyleSelectionDisabled = function () {
            if (this.disabledSelection) {
                return { 'cursor': 'default' };
            }
        };
        SelectFilterComponent.prototype.ngOnInit = function () {
            this.settings = Object.assign(this.defaultSettings, this.settings);
            this.texts = Object.assign(this.defaultTexts, this.texts);
            this.title = this.texts.defaultTitle || '';
            this.filterControl.valueChanges
                .pipe(operators.takeUntil(this.destroyed$))
                .subscribe(function () {
                this.updateRenderItems();
                if (this.settings.isLazyLoad) {
                    this.load();
                }
            }.bind(this));
        };
        SelectFilterComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes['options']) {
                var previousSelection = this.model;
                this.options = this.options || [];
                this.parents = this.options
                    .filter(function (option) { return typeof option.parentId === 'number'; })
                    .map(function (option) { return option.parentId; });
                this.updateRenderItems();
                if (this.settings.selectAddedValues && this.loadedValueIds.length === 0) {
                    this.loadedValueIds = this.loadedValueIds.concat(changes.options.currentValue.map(function (value) { return value.id; }));
                }
                if (this.settings.selectAddedValues && changes.options.previousValue) {
                    var addedValues_1 = changes.options.currentValue.filter(function (value) { return _this.loadedValueIds.indexOf(value.id) === -1; });
                    this.loadedValueIds.concat(addedValues_1.map(function (value) { return value.id; }));
                    if (this.checkAllStatus) {
                        this.addChecks(addedValues_1);
                    }
                    else if (this.checkAllSearchRegister.size > 0) {
                        this.checkAllSearchRegister.forEach(function (searchValue) { return _this.addChecks(_this.applyFilters(addedValues_1, searchValue)); });
                    }
                }
                if (this.texts) {
                    this.updateTitle();
                }
                if (previousSelection != this.model) {
                    this.onModelChange(this.model);
                    this.onModelTouched();
                }
            }
            if (changes['texts'] && !changes['texts'].isFirstChange()) {
                this.updateTitle();
            }
        };
        SelectFilterComponent.prototype.ngOnDestroy = function () {
            this.destroyed$.next();
        };
        SelectFilterComponent.prototype.updateRenderItems = function () {
            this.renderItems = !this.searchLimitApplied || this.filterControl.value.length >= this.searchRenderAfter;
            this.filteredOptions = this.applyFilters(this.options, this.settings.isLazyLoad ? '' : this.filterControl.value);
            this.renderFilteredOptions = this.renderItems ? this.filteredOptions : [];
        };
        SelectFilterComponent.prototype.applyFilters = function (options, value) {
            return (this.searchFilter.transform(options, value, this.settings.searchMaxLimit, this.settings.searchMaxRenderedItems));
        };
        SelectFilterComponent.prototype.writeValue = function (value) {
            if (value !== undefined && value !== null) {
                this.model = Array.isArray(value) ? value : [value];
            }
            else {
                this.model = [];
            }
        };
        SelectFilterComponent.prototype.registerOnChange = function (fn) {
            this.onModelChange = fn;
        };
        SelectFilterComponent.prototype.registerOnTouched = function (fn) {
            this.onModelTouched = fn;
        };
        SelectFilterComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        SelectFilterComponent.prototype.ngDoCheck = function () {
            var changes = this.differ.diff(this.model);
            if (changes) {
                this.updateNumSelected();
                this.updateTitle();
            }
        };
        SelectFilterComponent.prototype.validate = function (_c) {
            return (this.model && this.model.length) ? null : {
                required: {
                    valid: false,
                },
            };
        };
        SelectFilterComponent.prototype.registerOnValidatorChange = function (_fn) {
            throw new Error('Method not implemented.');
        };
        SelectFilterComponent.prototype.clearSearch = function (event) {
            if (event.stopPropagation) {
                event.stopPropagation();
            }
            this.filterControl.setValue('');
        };
        SelectFilterComponent.prototype.toggleDropdown = function () {
            this.isVisible = !this.isVisible;
            this.isVisible ? this.dropdownOpened.emit() : this.dropdownClosed.emit();
        };
        SelectFilterComponent.prototype.isSelected = function (option) {
            return this.model && this.model.indexOf(option.value) > -1;
        };
        SelectFilterComponent.prototype.setSelected = function (_event, option) {
            var _this = this;
            if (option.isLabel) {
                return;
            }
            if (!this.disabledSelection) {
                if (_event.stopPropagation) {
                    _event.stopPropagation();
                }
                var index = this.model.indexOf(option.value);
                var isAtSelectionLimit = this.settings.selectionLimit > 0 && this.model.length >= this.settings.selectionLimit;
                if (index > -1) {
                    var removeItem_1 = function (idx, id) {
                        _this.model.splice(idx, 1);
                        _this.onRemoved.emit(id);
                    };
                    if ((this.settings.minSelectionLimit === undefined) || (this.numSelected > this.settings.minSelectionLimit)) {
                        removeItem_1(index, option.value);
                    }
                    var parentIndex = option.parentId && this.model.indexOf(option.parentId);
                    if (parentIndex > -1) {
                        removeItem_1(parentIndex, option.parentId);
                    }
                    else if (this.parents.indexOf(option.value) > -1) {
                        this.options.filter(function (child) { return _this.model.indexOf(child.value) > -1 && child.parentId === option.value; })
                            .forEach(function (child) { return removeItem_1(_this.model.indexOf(child.value), child.value); });
                    }
                }
                else if (isAtSelectionLimit && !this.settings.autoUnselect) {
                    this.selectionLimitReached.emit(this.model.length);
                    return;
                }
                else {
                    var addItem_1 = function (id) {
                        _this.model.push(id);
                        _this.onAdded.emit(id);
                    };
                    addItem_1(option.value);
                    if (!isAtSelectionLimit) {
                        if (option.parentId) {
                            var children = this.options.filter(function (child) { return child.value !== option.value && child.parentId === option.parentId; });
                            if (children.every(function (child) { return _this.model.indexOf(child.value) > -1; })) {
                                addItem_1(option.parentId);
                            }
                        }
                        else if (this.parents.indexOf(option.value) > -1) {
                            var children = this.options.filter(function (child) { return _this.model.indexOf(child.value) < 0 && child.parentId === option.value; });
                            children.forEach(function (child) { return addItem_1(child.value); });
                        }
                    }
                    else {
                        var removedOption = this.model.shift();
                        this.onRemoved.emit(removedOption);
                    }
                }
                if (this.settings.closeOnSelect) {
                    this.toggleDropdown();
                }
                this.model = this.model.slice();
                this.onModelChange(this.model);
                this.onModelTouched();
            }
        };
        SelectFilterComponent.prototype.updateNumSelected = function () {
            var _this = this;
            this.numSelected = this.model.filter(function (id) { return _this.parents.indexOf(id) < 0; }).length || 0;
        };
        SelectFilterComponent.prototype.updateTitle = function () {
            var _this = this;
            if (this.numSelected === 0 || this.settings.fixedTitle) {
                this.title = (this.texts) ? this.texts.defaultTitle : '';
            }
            else if (this.settings.displayAllSelectedText && this.model.length === this.options.length) {
                this.title = (this.texts) ? this.texts.allSelected : '';
            }
            else if (this.settings.dynamicTitleMaxItems && this.settings.dynamicTitleMaxItems >= this.numSelected) {
                this.title = this.options
                    .filter(function (option) {
                    return _this.model.indexOf(option.value) > -1;
                })
                    .map(function (option) { return option.key; })
                    .join(', ');
            }
            else {
                this.title = this.numSelected
                    + ' '
                    + (this.numSelected === 1 ? this.texts.checked : this.texts.checkedPlural);
            }
        };
        SelectFilterComponent.prototype.searchFilterApplied = function () {
            return this.settings.enableSearch && this.filterControl.value && this.filterControl.value.length > 0;
        };
        SelectFilterComponent.prototype.addChecks = function (options) {
            var checkedOptions = options
                .filter(function (option) {
                if (this.model.indexOf(option.value) === -1) {
                    this.onAdded.emit(option.value);
                    return true;
                }
                return false;
            }.bind(this)).map(function (option) { return option.value; });
            this.model = this.model.concat(checkedOptions);
        };
        SelectFilterComponent.prototype.checkAll = function () {
            if (!this.disabledSelection) {
                this.addChecks(!this.searchFilterApplied() ? this.options : this.filteredOptions);
                if (this.settings.selectAddedValues) {
                    if (this.searchFilterApplied() && !this.checkAllStatus) {
                        this.checkAllSearchRegister.add(this.filterControl.value);
                    }
                    else {
                        this.checkAllSearchRegister.clear();
                        this.checkAllStatus = true;
                    }
                    this.load();
                }
                this.onModelChange(this.model);
                this.onModelTouched();
            }
        };
        SelectFilterComponent.prototype.uncheckAll = function () {
            var _this = this;
            if (!this.disabledSelection) {
                var checkedOptions = this.model;
                var unCheckedOptions_1 = (!this.searchFilterApplied() ? this.model
                    : this.filteredOptions.map(function (option) { return option.value; }));
                // set unchecked options only to the ones that were checked
                unCheckedOptions_1 = checkedOptions.filter(function (item) { return _this.model.includes(item); });
                this.model = this.model.filter(function (id) {
                    if (((unCheckedOptions_1.indexOf(id) < 0) && (_this.settings.minSelectionLimit === undefined)) || ((unCheckedOptions_1.indexOf(id) < _this.settings.minSelectionLimit))) {
                        return true;
                    }
                    else {
                        _this.onRemoved.emit(id);
                        return false;
                    }
                });
                if (this.settings.selectAddedValues) {
                    if (this.searchFilterApplied()) {
                        if (this.checkAllSearchRegister.has(this.filterControl.value)) {
                            this.checkAllSearchRegister.delete(this.filterControl.value);
                            this.checkAllSearchRegister.forEach(function (searchTerm) {
                                var filterOptions = this.applyFilters(this.options.filter(function (option) { return unCheckedOptions_1.includes(option.name); }), searchTerm);
                                this.addChecks(filterOptions);
                            }.bind(this));
                        }
                    }
                    else {
                        this.checkAllSearchRegister.clear();
                        this.checkAllStatus = false;
                    }
                    this.load();
                }
                this.onModelChange(this.model);
                this.onModelTouched();
            }
        };
        SelectFilterComponent.prototype.preventCheckboxCheck = function (event, option) {
            if (this.settings.selectionLimit && !this.settings.autoUnselect &&
                this.model.length >= this.settings.selectionLimit &&
                this.model.indexOf(option.value) === -1 &&
                event.preventDefault) {
                event.preventDefault();
            }
        };
        SelectFilterComponent.prototype.isCheckboxDisabled = function () {
            return this.disabledSelection;
        };
        SelectFilterComponent.prototype.checkScrollPosition = function (ev) {
            var scrollTop = ev.target.scrollTop;
            var scrollHeight = ev.target.scrollHeight;
            var scrollElementHeight = ev.target.clientHeight;
            var roundingPixel = 1;
            var gutterPixel = 1;
            if (scrollTop >= scrollHeight - (1 + this.settings.loadViewDistance) * scrollElementHeight - roundingPixel - gutterPixel) {
                this.load();
            }
        };
        SelectFilterComponent.prototype.checkScrollPropagation = function (ev, element) {
            var scrollTop = element.scrollTop;
            var scrollHeight = element.scrollHeight;
            var scrollElementHeight = element.clientHeight;
            if ((ev.deltaY > 0 && scrollTop + scrollElementHeight >= scrollHeight) || (ev.deltaY < 0 && scrollTop <= 0)) {
                ev = ev || window.event;
                ev.preventDefault && ev.preventDefault();
                ev.returnValue = false;
            }
        };
        SelectFilterComponent.prototype.load = function () {
            this.onLazyLoad.emit({
                length: this.options.length,
                filter: this.filterControl.value,
                checkAllSearches: this.checkAllSearchRegister,
                checkAllStatus: this.checkAllStatus
            });
        };
        Object.defineProperty(SelectFilterComponent.prototype, "tagTextInput", {
            get: function () {
                if (this._tagTextInput) {
                    this._tagTextInput.nativeElement.focus();
                }
                return this._tagTextInput;
            },
            set: function (v) {
                this._tagTextInput = v;
                if (this._tagTextInput != undefined)
                    this._tagTextInput.nativeElement.focus();
            },
            enumerable: true,
            configurable: true
        });
        SelectFilterComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: forms.FormBuilder },
            { type: MultiSelectSearchFilter },
            { type: core.IterableDiffers }
        ]; };
        __decorate([
            core.Input()
        ], SelectFilterComponent.prototype, "options", void 0);
        __decorate([
            core.Input()
        ], SelectFilterComponent.prototype, "settings", void 0);
        __decorate([
            core.Input()
        ], SelectFilterComponent.prototype, "texts", void 0);
        __decorate([
            core.Input()
        ], SelectFilterComponent.prototype, "disabled", void 0);
        __decorate([
            core.Input()
        ], SelectFilterComponent.prototype, "disabledSelection", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "selectionLimitReached", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "dropdownClosed", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "dropdownOpened", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "onAdded", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "onRemoved", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "onLazyLoad", void 0);
        __decorate([
            core.Output()
        ], SelectFilterComponent.prototype, "onFilter", void 0);
        __decorate([
            core.HostListener('document: click', ['$event.target'])
        ], SelectFilterComponent.prototype, "onClick", null);
        __decorate([
            core.ViewChild('tagTextInput')
        ], SelectFilterComponent.prototype, "tagTextInput", null);
        SelectFilterComponent = __decorate([
            core.Component({
                selector: 'select-filter',
                template: "<ng-template [ngIf]=\"filter.loading == true\">\r\n  Filtre y\u00FCkleniyor\r\n</ng-template>\r\n\r\n<ng-template [ngIf]=\"filter.loading == false && filter.items.length > 0\">\r\n\r\n  <div class=\"dropdown\" [ngClass]=\"settings.containerClasses\" [class.open]=\"isVisible\">\r\n    <button type=\"button\" class=\"dropdown-toggle\" [ngClass]=\"settings.buttonClasses\" (click)=\"toggleDropdown()\"\r\n      [disabled]=\"disabled\">{{ title }}\r\n      <span class=\"caret\"></span>\r\n    </button>\r\n    <ul #scroller *ngIf=\"isVisible\" class=\"dropdown-menu\"\r\n      (scroll)=\"settings.isLazyLoad ? checkScrollPosition($event) : null\"\r\n      (wheel)=\"settings.stopScrollPropagation ? checkScrollPropagation($event, scroller) : null\"\r\n      [class.pull-right]=\"settings.pullRight\" [class.dropdown-menu-right]=\"settings.pullRight\"\r\n      [style.max-height]=\"settings.maxHeight\" style=\"display: block; height: auto; overflow-y: auto;\">\r\n      <li class=\"dropdown-item search\" *ngIf=\"settings.enableSearch\">\r\n        <div class=\"input-group input-group-sm\">\r\n          <span class=\"input-group-addon\" id=\"sizing-addon3\">\r\n            <i class=\"fa fa-search\"></i>\r\n          </span>\r\n          <input #tagTextInput type=\"text\" class=\"form-control\" placeholder=\"{{ texts.searchPlaceholder }}\"\r\n            aria-describedby=\"sizing-addon3\" [formControl]=\"filterControl\" autofocus>\r\n          <span class=\"input-group-btn\" *ngIf=\"filterControl.value.length > 0\">\r\n            <button class=\"btn btn-default btn-secondary\" type=\"button\" (click)=\"clearSearch($event)\">\r\n              <i class=\"fa fa-times\"></i>\r\n            </button>\r\n          </span>\r\n        </div>\r\n      </li>\r\n      <li class=\"dropdown-divider divider\" *ngIf=\"settings.enableSearch\"></li>\r\n      <li class=\"dropdown-item check-control check-control-check\" *ngIf=\"settings.showCheckAll && !disabledSelection\">\r\n        <a href=\"javascript:;\" role=\"menuitem\" tabindex=\"-1\" (click)=\"checkAll()\">\r\n          <span style=\"width: 16px;\" class=\"fa fa-check\"></span>\r\n          {{ texts.checkAll }}\r\n        </a>\r\n      </li>\r\n      <li class=\"dropdown-item check-control check-control-uncheck\"\r\n        *ngIf=\"settings.showUncheckAll && !disabledSelection\">\r\n        <a href=\"javascript:;\" role=\"menuitem\" tabindex=\"-1\" (click)=\"uncheckAll()\">\r\n          <span style=\"width: 16px;\"\r\n            [ngClass]=\"{'fa fa-trash': settings.checkedStyle !== 'fontawesome','fa fa-times': settings.checkedStyle === 'fontawesome'}\"></span>\r\n          {{ texts.uncheckAll }}\r\n        </a>\r\n      </li>\r\n      <li *ngIf=\"settings.showCheckAll || settings.showUncheckAll\" class=\"dropdown-divider divider\"></li>\r\n      <li *ngIf=\"!renderItems\" class=\"dropdown-item empty\">{{ texts.searchNoRenderText }}</li>\r\n      <li *ngIf=\"renderItems && !renderFilteredOptions.length\" class=\"dropdown-item empty\">{{ texts.searchEmptyResult\r\n        }}</li>\r\n      <li class=\"dropdown-item\" *ngFor=\"let option of renderFilteredOptions\" (click)=\"setSelected($event, option)\"\r\n        [ngStyle]=\"getItemStyle(option)\" [ngClass]=\"option.classes\" [class.dropdown-header]=\"option.isLabel\">\r\n        <a *ngIf=\"!option.isLabel; else label\" href=\"javascript:;\" role=\"menuitem\" tabindex=\"-1\"\r\n          [style.padding-left]=\"this.parents.length>0&&this.parents.indexOf(option.value)<0&&'30px'\"\r\n          [ngStyle]=\"getItemStyleSelectionDisabled()\">\r\n          <ng-container [ngSwitch]=\"settings.checkedStyle\">\r\n            <input *ngSwitchCase=\"'checkboxes'\" type=\"checkbox\" [checked]=\"isSelected(option)\"\r\n              (click)=\"preventCheckboxCheck($event, option)\" [disabled]=\"isCheckboxDisabled()\"\r\n              [ngStyle]=\"getItemStyleSelectionDisabled()\" />\r\n            <span *ngSwitchCase=\"'fa'\" style=\"width: 16px;\" class=\"fa\" [class.fa-check]=\"isSelected(option)\"></span>\r\n            <span *ngSwitchCase=\"'fontawesome'\" style=\"width: 16px;display: inline-block;\">\r\n              <i *ngIf=\"isSelected(option)\" class=\"fa fa-check\" aria-hidden=\"true\"></i>\r\n            </span>\r\n          </ng-container>\r\n          <span [ngClass]=\"settings.itemClasses\"\r\n            [style.font-weight]=\"this.parents.indexOf(option.value)>=0?'bold':'normal'\">\r\n            {{ option.key }}\r\n          </span>\r\n        </a>\r\n        <ng-template #label>{{ option.key }}</ng-template>\r\n      </li>\r\n    </ul>\r\n  </div>\r\n\r\n</ng-template>\r\n<ng-template *ngIf=\"filter.loading == false && filter.items.length == 0\">\r\n  Filtre bulunamad\u0131\r\n</ng-template>",
                providers: [MULTISELECT_VALUE_ACCESSOR, MultiSelectSearchFilter],
                styles: ["a{outline:0!important}.dropdown-inline{display:inline-block}.dropdown-toggle .caret{margin-left:4px;white-space:nowrap;display:inline-block}"]
            })
        ], SelectFilterComponent);
        return SelectFilterComponent;
    }(BaseFilter));

    var DateHelper = /** @class */ (function () {
        function DateHelper() {
        }
        DateHelper.removeTimezoneEffect = function (date) {
            var utcDate = new Date(date);
            utcDate.setTime(utcDate.getTime() - (utcDate.getTimezoneOffset() * 60 * 1000));
            return utcDate;
        };
        DateHelper.addTimezoneEffect = function (date) {
            var utcDate = new Date(date);
            utcDate.setTime(utcDate.getTime() + (utcDate.getTimezoneOffset() * 60 * 1000));
            return utcDate;
        };
        return DateHelper;
    }());

    var DateFilterComponent = /** @class */ (function (_super) {
        __extends(DateFilterComponent, _super);
        function DateFilterComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(DateFilterComponent.prototype, "filterValue", {
            get: function () {
                return this._filterValue;
            },
            set: function (v) {
                if (v == this._filterValue)
                    return;
                if (v == undefined)
                    this._filterValue = undefined;
                else if (v instanceof Date)
                    this._filterValue = v;
                else
                    this._filterValue = DateHelper.addTimezoneEffect(new Date(v));
            },
            enumerable: true,
            configurable: true
        });
        DateFilterComponent.prototype.ngOnInit = function () {
        };
        DateFilterComponent.prototype.onFilterOperationChanged = function ($event) {
            if ($event != this.filter.operation) {
                this.filter.operation = $event;
                if (this.triggerFilterChanged)
                    this.onFilterChanged.emit({ filter: this.filter });
            }
        };
        DateFilterComponent.prototype.searchInputChanged = function () {
            if (this.filterValue != this.filter.value) {
                if (this.filterValue === undefined) {
                    this.filter.value = undefined;
                }
                else {
                    var date = DateHelper.removeTimezoneEffect(new Date(this.filterValue));
                    if (isNaN(date.getTime()))
                        this.filter.value = undefined;
                    else
                        this.filter.value = date;
                }
                if (this.triggerFilterChanged)
                    this.onFilterChanged.emit({ filter: this.filter });
            }
        };
        DateFilterComponent = __decorate([
            core.Component({
                selector: 'date-filter',
                template: "<div class=\"input-group\" *ngIf=\"filter\">\r\n    <date-picker style=\"display: table-cell; vertical-align: top;\" [(selectedDate)]=\"filterValue\" (selectedDateChange)=\"searchInputChanged()\"\r\n        [shouldDisplayIcon]=\"false\"></date-picker>\r\n    <button type=\"button\" class=\"input-group-btn btn btn-default dropdown-toggle filter-input-btn\" data-toggle=\"dropdown\"\r\n        aria-haspopup=\"true\" aria-expanded=\"false\" style=\"box-shadow: none !important; padding-left: 8px; padding-right: 8px;\">\r\n        <ng-template [ngIf]=\"filter.operation != undefined\">{{filter.operation}}</ng-template>\r\n        <ng-template [ngIf]=\"filter.operation == undefined\">=</ng-template>\r\n    </button>\r\n    <ul class=\"dropdown-menu dropdown-menu-right\" style=\"min-width: 50px; text-align: center;\">\r\n        <li><a (click)=\"onFilterOperationChanged(undefined)\">=</a></li>\r\n        <li><a (click)=\"onFilterOperationChanged('>')\">></a></li>\r\n        <li><a (click)=\"onFilterOperationChanged('>=')\">>=</a></li>\r\n        <li><a (click)=\"onFilterOperationChanged('<')\">\r\n                <</a> </li> <li><a (click)=\"onFilterOperationChanged('<=')\">\r\n                        <=</a> </li> </ul> </div>"
            })
        ], DateFilterComponent);
        return DateFilterComponent;
    }(BaseFilter));

    common.registerLocaleData(localeTr, 'tr');
    function HttpLoaderFactory(http) {
        return new httpLoader.TranslateHttpLoader(http);
    }
    function createTranslateLoader(http) {
        return new httpLoader.TranslateHttpLoader(http, '../assets/translations/i18n/', '.json');
    }
    var ɵ0 = (createTranslateLoader);
    var ClDataTableModule = /** @class */ (function () {
        function ClDataTableModule() {
        }
        ClDataTableModule = __decorate([
            core.NgModule({
                imports: [
                    platformBrowser.BrowserModule,
                    common.CommonModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    core$2.MatNativeDateModule,
                    tooltip.MatTooltipModule,
                    clAngularCore.ClCoreModule,
                    clAngularCheckbox.ClCheckboxModule,
                    clAngularCombobox.ClComboboxModule,
                    clAngularPager.ClPagerModule,
                    clAngularDatePicker.ClDatePickerModule,
                    core$1.TranslateModule.forChild({
                        loader: {
                            provide: core$1.TranslateLoader,
                            useFactory: ɵ0,
                            deps: [http.HttpClient]
                        }
                    })
                ],
                declarations: [
                    DataTableComponent,
                    DataTableFilterComponent,
                    InputFilterComponent,
                    BooleanFilterComponent,
                    SelectFilterComponent,
                    DateFilterComponent,
                    MultiSelectSearchFilter
                ],
                exports: [common.CommonModule, DataTableComponent, DataTableFilterComponent, MultiSelectSearchFilter, core$1.TranslateModule],
                providers: [http.HttpClient,
                    { provide: core.LOCALE_ID, useValue: 'tr' },
                    { provide: core$2.MAT_DATE_LOCALE, useValue: 'tr' }
                ]
            })
        ], ClDataTableModule);
        return ClDataTableModule;
    }());

    exports.Action = Action;
    exports.ClDataTableModule = ClDataTableModule;
    exports.Column = Column;
    exports.Condition = Condition;
    exports.DataTableComponent = DataTableComponent;
    exports.DataTableFilterComponent = DataTableFilterComponent;
    exports.Filter = Filter;
    exports.FilterItem = FilterItem;
    exports.HttpLoaderFactory = HttpLoaderFactory;
    exports.MultiSelectSearchFilter = MultiSelectSearchFilter;
    exports.TableConfiguration = TableConfiguration;
    exports.createTranslateLoader = createTranslateLoader;
    exports.ɵ0 = ɵ0;
    exports.ɵa = GenericFilterRepository;
    exports.ɵb = InputFilterComponent;
    exports.ɵc = BaseFilter;
    exports.ɵd = BooleanFilterComponent;
    exports.ɵe = SelectFilterComponent;
    exports.ɵf = DateFilterComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=cl-angular-data-table.umd.js.map
