import { Column } from './column';
import { SearchCriteria } from 'cl-angular-core';
export declare class DataTableStorageModel {
    static filtersKey: string;
    static columnsKey: string;
    static isFullScreenKey: string;
    static isScrollableKey: string;
    static isCompressedKey: string;
    static pageIndexKey: string;
    static pageCountKey: string;
    dataTableID: number;
    filters: SearchCriteria[];
    columns: Column[];
    isFullScreen: boolean;
    isScrollable: boolean;
    isCompressed: boolean;
    pageIndex: number;
    pageCount: number;
    static parse(element: any): DataTableStorageModel;
}
