import { DataTableStorageModel } from '../models/data-table-storage';
export declare class LocalStorageHandler {
    static userNameKey: string;
    static userEmailKey: string;
    static tokenKey: string;
    static sessionKey: string;
    static userFullNameKey: string;
    static userIdKey: string;
    static userRowguidKey: string;
    static userTypeKey: string;
    static userPhotoPathKey: string;
    private static originalUserIDKey;
    static departments: string;
    private static dataTableSettingsKey;
    static getUserRowguid(): string;
    static getUserId(): number;
    private static setValueForKey;
    private static getStringForKey;
    static setOriginalUserID(userID: number): any;
    static getOriginalUserID(): string;
    static setDataTableSettings(dataTable: DataTableStorageModel): void;
    static getDataTableSettings(dataTableID: number): DataTableStorageModel;
    static removeDataTableFilter(dataTableID: number): DataTableStorageModel;
}
