import { HttpClient } from '@angular/common/http';
import { SearchCriteria } from 'cl-angular-core';
import { Dictionary } from 'cl-angular-core';
import { ResponseModel } from 'cl-angular-core';
export declare class GenericFilterRepository {
    http: HttpClient;
    constructor(http: HttpClient);
    getAll(target: string, pageIndex: number, pageCount: number, includeInactive: boolean, filter?: SearchCriteria[], sort?: Dictionary, extendStrings?: Array<string>, includeDeleted?: boolean, includeSystemColumns?: boolean): Promise<ResponseModel<any>>;
    static getPath(input: string): string;
    static pluralize(element: string): string;
}
